###################################################################################
#
#    This file was generated using Parse::Eyapp version 1.109.
#
# (c) Parse::Yapp Copyright 1998-2001 Francois Desarmenien.
# (c) Parse::Eyapp Copyright 2006-2007 Casiano Rodriguez-Leon. Universidad de La Laguna.
#        Don't edit this file, use source file "src/sh.yp" instead.
#
#             ANY CHANGE MADE HERE WILL BE LOST !
#
###################################################################################
package ShParser;
use strict;

push @ShParser::ISA, 'Parse::Eyapp::Driver';


{ ###########Included /usr/local/share/perl/5.10.0/Parse/Eyapp/Driver.pm file
#
# Module Parse::Eyapp::Driver
#
# This module is part of the Parse::Eyapp package available on your
# nearest CPAN
#
# This module is based on Francois Desarmenien Parse::Yapp module
# (c) Parse::Yapp Copyright 1998-2001 Francois Desarmenien, all rights reserved.
# (c) Parse::Eyapp Copyright 2006 Casiano Rodriguez-Leon, all rights reserved.

package Parse::Eyapp::Driver;

require 5.006;

use strict;

our ( $VERSION, $COMPATIBLE, $FILENAME );

$VERSION = '1.109';
$COMPATIBLE = '0.07';
$FILENAME=__FILE__;

use Carp;

#Known parameters, all starting with YY (leading YY will be discarded)
my(%params)=(YYLEX => 'CODE', 'YYERROR' => 'CODE', YYVERSION => '',
	     YYRULES => 'ARRAY', YYSTATES => 'ARRAY', YYDEBUG => '', 
	     # added by Casiano
	     #YYPREFIX  => '',  # Not allowed at YYParse time but in new
	     YYFILENAME => '', 
       YYBYPASS   => '',
	     YYGRAMMAR  => 'ARRAY', 
	     YYTERMS    => 'HASH',
	     YYBUILDINGTREE  => '',
	     ); 
my (%newparams) = (%params, YYPREFIX => '',);

#Mandatory parameters
my(@params)=('LEX','RULES','STATES');

sub new {
    my($class)=shift;
	my($errst,$nberr,$token,$value,$check,$dotpos);
    my($self)={ ERROR => \&_Error,
				ERRST => \$errst,
				NBERR => \$nberr,
				TOKEN => \$token,
				VALUE => \$value,
				DOTPOS => \$dotpos,
				STACK => [],
				DEBUG => 0,
				PREFIX => "",
				CHECK => \$check };

	_CheckParams( [], \%newparams, \@_, $self );

		exists($$self{VERSION})
	and	$$self{VERSION} < $COMPATIBLE
	and	croak "Eyapp driver version $VERSION ".
			  "incompatible with version $$self{VERSION}:\n".
			  "Please recompile parser module.";

        ref($class)
    and $class=ref($class);

    bless($self,$class);
}

sub YYParse {
    my($self)=shift;
    my($retval);

	_CheckParams( \@params, \%params, \@_, $self );

	if($$self{DEBUG}) {
		_DBLoad();
		$retval = eval '$self->_DBParse()';#Do not create stab entry on compile
        $@ and die $@;
	}
	else {
		$retval = $self->_Parse();
	}
    return $retval;
}

sub YYData {
	my($self)=shift;

		exists($$self{USER})
	or	$$self{USER}={};

	$$self{USER};
	
}

sub YYErrok {
	my($self)=shift;

	${$$self{ERRST}}=0;
    undef;
}

sub YYNberr {
	my($self)=shift;

	${$$self{NBERR}};
}

sub YYRecovering {
	my($self)=shift;

	${$$self{ERRST}} != 0;
}

sub YYAbort {
	my($self)=shift;

	${$$self{CHECK}}='ABORT';
    undef;
}

sub YYAccept {
	my($self)=shift;

	${$$self{CHECK}}='ACCEPT';
    undef;
}

sub YYError {
	my($self)=shift;

	${$$self{CHECK}}='ERROR';
    undef;
}

sub YYSemval {
	my($self)=shift;
	my($index)= $_[0] - ${$$self{DOTPOS}} - 1;

		$index < 0
	and	-$index <= @{$$self{STACK}}
	and	return $$self{STACK}[$index][1];

	undef;	#Invalid index
}

### Casiano methods

sub YYLhs { 
  # returns the syntax variable on
  # the left hand side of the current production
  my $self = shift;

  return $self->{CURRENT_LHS}
}

sub YYRuleindex { 
  # returns the index of the rule
  # counting the super rule as rule 0
  my $self = shift;

  return $self->{CURRENT_RULE}
}

sub YYRightside { 
  # returns the rule
  # counting the super rule as rule 0
  my $self = shift;

  return @{$self->{GRAMMAR}->[$self->{CURRENT_RULE}]->[2]};
}

sub YYIsterm {
  my $self = shift;
  my $symbol = shift;

  return exists ($self->{TERMS}->{$symbol});
}

sub YYIssemantic {
  my $self = shift;
  my $symbol = shift;

  $self->{TERMS}->{$symbol} = shift if @_;
  return ($self->{TERMS}->{$symbol});
}


sub YYName {
  my $self = shift;

  my $current_rule = $self->{GRAMMAR}->[$self->{CURRENT_RULE}];
  $current_rule->[0] = shift if @_;
  return $current_rule->[0];
}

sub YYPrefix {
  my $self = shift;

  $self->{PREFIX} = $_[0] if @_;
  #$self->{PREFIX} .= '::' unless  $self->{PREFIX} =~ /::$/;
  $self->{PREFIX};
}

sub YYFilename {
  my $self = shift;

  $self->{FILENAME} = $_[0] if @_;
  $self->{FILENAME};
}

sub YYBypass {
  my $self = shift;

  $self->{BYPASS} = $_[0] if @_;
  $self->{BYPASS};
}

sub YYBypassrule {
  my $self = shift;

  $self->{GRAMMAR}->[$self->{CURRENT_RULE}][3] = $_[0] if @_;
  return $self->{GRAMMAR}->[$self->{CURRENT_RULE}][3];
}

sub YYFirstline {
  my $self = shift;

  $self->{FIRSTLINE} = $_[0] if @_;
  $self->{FIRSTLINE};
}

# Influences the behavior of YYActionforT_X1X2
# YYActionforT_single and YYActionforT_empty
# If true these methods will build simple lists of attributes 
# for the lists operators X*, X+ and X? and parenthesis (X Y)
# Otherwise the classic node construction for the
# syntax tree is used
sub YYBuildingTree {
  my $self = shift;

  $self->{BUILDINGTREE} = $_[0] if @_;
  $self->{BUILDINGTREE};
}

sub BeANode {
  my $class = shift;

    no strict 'refs';
    push @{$class."::ISA"}, "Parse::Eyapp::Node" unless $class->isa("Parse::Eyapp::Node");
}

#sub BeATranslationScheme {
#  my $class = shift;
#
#    no strict 'refs';
#    push @{$class."::ISA"}, "Parse::Eyapp::TranslationScheme" unless $class->isa("Parse::Eyapp::TranslationScheme");
#}

{
  my $attr =  sub { 
      $_[0]{attr} = $_[1] if @_ > 1;
      $_[0]{attr}
    };

  sub make_node_classes {
    my $self = shift;
    my $prefix = $self->YYPrefix() || '';

    { no strict 'refs';
      *{$prefix."TERMINAL::attr"} = $attr;
    }

    for (@_) {
       BeANode("$prefix$_"); 
    }
  }
}

####################################################################
# Usage      : ????
# Purpose    : Responsible for the %tree directive 
#              On each production the default action becomes:
#              sub { goto &Parse::Eyapp::Driver::YYBuildAST }
#
# Returns    : ????
# Parameters : ????
# Throws     : no exceptions
# Comments   : none
# See Also   : n/a
# To Do      : many things: Optimize this!!!!
sub YYBuildAST { 
  my $self = shift;
  my $PREFIX = $self->YYPrefix();
  my @right = $self->YYRightside(); # Symbols on the right hand side of the production
  my $lhs = $self->YYLhs;
  my $name = $self->YYName();
  my $bypass = $self->YYBypassrule; # Boolean: shall we do bypassing of lonely nodes?
  my $class = "$PREFIX$name";
  my @children;

  my $node = bless {}, $class;

  for(my $i = 0; $i < @right; $i++) {
    $_ = $right[$i]; # The symbol
    my $ch = $_[$i]; # The attribute/reference
    if ($self->YYIssemantic($_)) {
      my $class = $PREFIX.'TERMINAL';
      my $node = bless { token => $_, attr => $ch, children => [] }, $class;
      push @children, $node;
      next;
    }

    if ($self->YYIsterm($_)) {
      TERMINAL::save_attributes($ch, $node) if UNIVERSAL::can($PREFIX."TERMINAL", "save_attributes");
      next;
    }

    if (UNIVERSAL::isa($ch, $PREFIX."_PAREN")) { # Warning: weak code!!!
      push @children, @{$ch->{children}};
      next;
    }

    # If it is an intermediate semantic action skip it
    next if $_ =~ qr{@}; # intermediate rule
    next unless ref($ch);
    push @children, $ch;
  }

  
  if ($bypass and @children == 1) {
    $node = $children[0]; 
    # Re-bless unless is "an automatically named node", but the characterization of this is 
    bless $node, $class unless $name =~ /${lhs}_\d+$/; # lazy, weak (and wicked).
    return $node;
  }
  $node->{children} = \@children; 
  return $node;
}

sub YYBuildTS { 
  my $self = shift;
  my $PREFIX = $self->YYPrefix();
  my @right = $self->YYRightside(); # Symbols on the right hand side of the production
  my $lhs = $self->YYLhs;
  my $name = $self->YYName();
  my $class;
  my @children;

  for(my $i = 0; $i < @right; $i++) {
    $_ = $right[$i]; # The symbol
    my $ch = $_[$i]; # The attribute/reference

    if ($self->YYIsterm($_)) { 
      $class = $PREFIX.'TERMINAL';
      push @children, bless { token => $_, attr => $ch, children => [] }, $class;
      next;
    }

    if (UNIVERSAL::isa($ch, $PREFIX."_PAREN")) { # Warning: weak code!!!
      push @children, @{$ch->{children}};
      next;
    }

    # Substitute intermediate code node _CODE(CODE()) by CODE()
    if (UNIVERSAL::isa($ch, $PREFIX."_CODE")) { # Warning: weak code!!!
      push @children, $ch->child(0);
      next;
    }

    next unless ref($ch);
    push @children, $ch;
  }

  if (unpack('A1',$lhs) eq '@') { # class has to be _CODE check
          $lhs =~ /^\@[0-9]+\-([0-9]+)$/
      or  croak "In line rule name '$lhs' ill formed: report it as a BUG.\n";
      my $dotpos = $1;
 
      croak "Fatal error building metatree when processing  $lhs -> @right" 
      unless exists($_[$dotpos]) and UNIVERSAL::isa($_[$dotpos], 'CODE') ; 
      push @children, $_[$dotpos];
  }
  else {
    my $code = $_[@right];
    if (UNIVERSAL::isa($code, 'CODE')) {
      push @children, $code; 
    }
    else {
      croak "Fatal error building translation scheme. Code or undef expected" if (defined($code));
    }
  }

  $class = "$PREFIX$name";
  my $node = bless { children => \@children }, $class; 
  $node;
}

sub YYActionforT_TX1X2_tree {
  my $self = shift;
  my $head = shift;
  my $PREFIX = $self->YYPrefix();
  my @right = $self->YYRightside();
  my $class;

  for(my $i = 1; $i < @right; $i++) {
    $_ = $right[$i];
    my $ch = $_[$i-1];
    if ($self->YYIssemantic($_)) {
      $class = $PREFIX.'TERMINAL';
      push @{$head->{children}}, bless { token => $_, attr => $ch, children => [] }, $class;
      
      next;
    }
    next if $self->YYIsterm($_);
    if (ref($ch) eq  $PREFIX."_PAREN") { # Warning: weak code!!!
      push @{$head->{children}}, @{$ch->{children}};
      next;
    }
    next unless ref($ch);
    push @{$head->{children}}, $ch;
  }

  return $head;
}

# For * and + lists 
# S2 -> S2 X         { push @$_[1] the node associated with X; $_[1] }
# S2 -> /* empty */  { a node with empty children }
sub YYActionforT_TX1X2 {
  goto &YYActionforT_TX1X2_tree if $_[0]->YYBuildingTree;

  my $self = shift;
  my $head = shift;

  push @$head, @_;
  return $head;
}

sub YYActionforParenthesis {
  goto &YYBuildAST if $_[0]->YYBuildingTree;

  my $self = shift;

  return [ @_ ];
}


sub YYActionforT_empty_tree {
  my $self = shift;
  my $PREFIX = $self->YYPrefix();
  my $name = $self->YYName();

  # Allow use of %name
  my $class = $PREFIX.$name;
  my $node = bless { children => [] }, $class;
  #BeANode($class);
  $node;
}

sub YYActionforT_empty {
  goto &YYActionforT_empty_tree  if $_[0]->YYBuildingTree;

  [];
}

sub YYActionforT_single_tree {
  my $self = shift;
  my $PREFIX = $self->YYPrefix();
  my $name = $self->YYName();
  my @right = $self->YYRightside();
  my $class;

  # Allow use of %name
  my @t;
  for(my $i = 0; $i < @right; $i++) {
    $_ = $right[$i];
    my $ch = $_[$i];
    if ($self->YYIssemantic($_)) {
      $class = $PREFIX.'TERMINAL';
      push @t, bless { token => $_, attr => $ch, children => [] }, $class;
      #BeANode($class);
      next;
    }
    next if $self->YYIsterm($_);
    if (ref($ch) eq  $PREFIX."_PAREN") { # Warning: weak code!!!
      push @t, @{$ch->{children}};
      next;
    }
    next unless ref($ch);
    push @t, $ch;
  }
  $class = $PREFIX.$name;
  my $node = bless { children => \@t }, $class;
  #BeANode($class);
  $node;
}

sub YYActionforT_single {
  goto &YYActionforT_single_tree  if $_[0]->YYBuildingTree;

  my $self = shift;
  [ @_ ];
}

### end Casiano methods

sub YYCurtok {
	my($self)=shift;

        @_
    and ${$$self{TOKEN}}=$_[0];
    ${$$self{TOKEN}};
}

sub YYCurval {
	my($self)=shift;

        @_
    and ${$$self{VALUE}}=$_[0];
    ${$$self{VALUE}};
}

sub YYExpect {
    my($self)=shift;

    keys %{$self->{STATES}[$self->{STACK}[-1][0]]{ACTIONS}}
}

sub YYLexer {
    my($self)=shift;

	$$self{LEX};
}


#################
# Private stuff #
#################


sub _CheckParams {
	my($mandatory,$checklist,$inarray,$outhash)=@_;
	my($prm,$value);
	my($prmlst)={};

	while(($prm,$value)=splice(@$inarray,0,2)) {
        $prm=uc($prm);
			exists($$checklist{$prm})
		or	croak("Unknow parameter '$prm'");
			ref($value) eq $$checklist{$prm}
		or	croak("Invalid value for parameter '$prm'");
        $prm=unpack('@2A*',$prm);
		$$outhash{$prm}=$value;
	}
	for (@$mandatory) {
			exists($$outhash{$_})
		or	croak("Missing mandatory parameter '".lc($_)."'");
	}
}

sub _Error {
	print "Parse error.\n";
}

sub _DBLoad {
	{
		no strict 'refs';

			exists(${__PACKAGE__.'::'}{_DBParse})#Already loaded ?
		and	return;
	}
	my($fname)=__FILE__;
	my(@drv);
	local $/ = "\n";
	open(DRV,"<$fname") or die "Report this as a BUG: Cannot open $fname";
  local $_;
	while(<DRV>) {
                	/^\s*sub\s+_Parse\s*{\s*$/ .. /^\s*}\s*#\s*_Parse\s*$/
        	and     do {
                	s/^#DBG>//;
                	push(@drv,$_);
        	}
	}
	close(DRV);

	$drv[0]=~s/_P/_DBP/;
	eval join('',@drv);
}

#Note that for loading debugging version of the driver,
#this file will be parsed from 'sub _Parse' up to '}#_Parse' inclusive.
#So, DO NOT remove comment at end of sub !!!
sub _Parse {
    my($self)=shift;

	my($rules,$states,$lex,$error)
     = @$self{ 'RULES', 'STATES', 'LEX', 'ERROR' };
	my($errstatus,$nberror,$token,$value,$stack,$check,$dotpos)
     = @$self{ 'ERRST', 'NBERR', 'TOKEN', 'VALUE', 'STACK', 'CHECK', 'DOTPOS' };

#DBG>	my($debug)=$$self{DEBUG};
#DBG>	my($dbgerror)=0;

#DBG>	my($ShowCurToken) = sub {
#DBG>		my($tok)='>';
#DBG>		for (split('',$$token)) {
#DBG>			$tok.=		(ord($_) < 32 or ord($_) > 126)
#DBG>					?	sprintf('<%02X>',ord($_))
#DBG>					:	$_;
#DBG>		}
#DBG>		$tok.='<';
#DBG>	};

	$$errstatus=0;
	$$nberror=0;
	($$token,$$value)=(undef,undef);
	@$stack=( [ 0, undef ] );
	$$check='';

    while(1) {
        my($actions,$act,$stateno);

        $stateno=$$stack[-1][0];
        $actions=$$states[$stateno];

#DBG>	print STDERR ('-' x 40),"\n";
#DBG>		$debug & 0x2
#DBG>	and	print STDERR "In state $stateno:\n";
#DBG>		$debug & 0x08
#DBG>	and	print STDERR "Stack:[".
#DBG>					 join(',',map { $$_[0] } @$stack).
#DBG>					 "]\n";


        if  (exists($$actions{ACTIONS})) {

				defined($$token)
            or	do {
				($$token,$$value)=&$lex($self);
#DBG>				$debug & 0x01
#DBG>			and	do { 
#DBG>       print STDERR "Need token. Got ".&$ShowCurToken."\n";
#DBG>     };
			};

            $act=   exists($$actions{ACTIONS}{$$token})
                    ?   $$actions{ACTIONS}{$$token}
                    :   exists($$actions{DEFAULT})
                        ?   $$actions{DEFAULT}
                        :   undef;
        }
        else {
            $act=$$actions{DEFAULT};
#DBG>			$debug & 0x01
#DBG>		and	print STDERR "Don't need token.\n";
        }

            defined($act)
        and do {

                $act > 0
            and do {        #shift

#DBG>				$debug & 0x04
#DBG>			and	print STDERR "Shift and go to state $act.\n";

					$$errstatus
				and	do {
					--$$errstatus;

#DBG>					$debug & 0x10
#DBG>				and	$dbgerror
#DBG>				and	$$errstatus == 0
#DBG>				and	do {
#DBG>					print STDERR "**End of Error recovery.\n";
#DBG>					$dbgerror=0;
#DBG>				};
				};


                push(@$stack,[ $act, $$value ]);

					$$token ne ''	#Don't eat the eof
				and	$$token=$$value=undef;
                next;
            };

            #reduce
            my($lhs,$len,$code,@sempar,$semval);
            ($lhs,$len,$code)=@{$$rules[-$act]};

#DBG>			$debug & 0x04
#DBG>		and	$act
#DBG>		#and	print STDERR "Reduce using rule ".-$act." ($lhs,$len): "; # old Parse::Yapp line
#DBG>		and	do { my @rhs = @{$self->{GRAMMAR}->[-$act]->[2]};
#DBG>            @rhs = ( '/* empty */' ) unless @rhs;
#DBG>            my $rhs = "@rhs";
#DBG>            $rhs = substr($rhs, 0, 30).'...' if length($rhs) > 30; # chomp if too large
#DBG>            print STDERR "Reduce using rule ".-$act." ($lhs --> $rhs): "; 
#DBG>          };

                $act
            or  $self->YYAccept();

            $$dotpos=$len;

                unpack('A1',$lhs) eq '@'    #In line rule
            and do {
                    $lhs =~ /^\@[0-9]+\-([0-9]+)$/
                or  die "In line rule name '$lhs' ill formed: ".
                        "report it as a BUG.\n";
                $$dotpos = $1;
            };

            @sempar =       $$dotpos
                        ?   map { $$_[1] } @$stack[ -$$dotpos .. -1 ]
                        :   ();

            $self->{CURRENT_LHS} = $lhs;
            $self->{CURRENT_RULE} = -$act; # count the super-rule?
            $semval = $code ? &$code( $self, @sempar )
                            : @sempar ? $sempar[0] : undef;

            splice(@$stack,-$len,$len);

                $$check eq 'ACCEPT'
            and do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Accept.\n";

				return($semval);
			};

                $$check eq 'ABORT'
            and	do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Abort.\n";

				return(undef);

			};

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Back to state $$stack[-1][0], then ";

                $$check eq 'ERROR'
            or  do {
#DBG>				$debug & 0x04
#DBG>			and	print STDERR 
#DBG>				    "go to state $$states[$$stack[-1][0]]{GOTOS}{$lhs}.\n";

#DBG>				$debug & 0x10
#DBG>			and	$dbgerror
#DBG>			and	$$errstatus == 0
#DBG>			and	do {
#DBG>				print STDERR "**End of Error recovery.\n";
#DBG>				$dbgerror=0;
#DBG>			};

			    push(@$stack,
                     [ $$states[$$stack[-1][0]]{GOTOS}{$lhs}, $semval ]);
                $$check='';
                next;
            };

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Forced Error recovery.\n";

            $$check='';

        };

        #Error
            $$errstatus
        or   do {

            $$errstatus = 1;
            &$error($self);
                $$errstatus # if 0, then YYErrok has been called
            or  next;       # so continue parsing

#DBG>			$debug & 0x10
#DBG>		and	do {
#DBG>			print STDERR "**Entering Error recovery.\n";
#DBG>			{ 
#DBG>       local $" = ", "; 
#DBG>       my @expect = map { ">$_<" } $self->YYExpect();
#DBG>       print STDERR "Expecting one of: @expect\n";
#DBG>     };
#DBG>			++$dbgerror;
#DBG>		};

            ++$$nberror;

        };

			$$errstatus == 3	#The next token is not valid: discard it
		and	do {
				$$token eq ''	# End of input: no hope
			and	do {
#DBG>				$debug & 0x10
#DBG>			and	print STDERR "**At eof: aborting.\n";
				return(undef);
			};

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Discard invalid token ".&$ShowCurToken.".\n";

			$$token=$$value=undef;
		};

        $$errstatus=3;

		while(	  @$stack
			  and (		not exists($$states[$$stack[-1][0]]{ACTIONS})
			        or  not exists($$states[$$stack[-1][0]]{ACTIONS}{error})
					or	$$states[$$stack[-1][0]]{ACTIONS}{error} <= 0)) {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Pop state $$stack[-1][0].\n";

			pop(@$stack);
		}

			@$stack
		or	do {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**No state left on stack: aborting.\n";

			return(undef);
		};

		#shift the error token

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Shift \$error token and go to state ".
#DBG>						 $$states[$$stack[-1][0]]{ACTIONS}{error}.
#DBG>						 ".\n";

		push(@$stack, [ $$states[$$stack[-1][0]]{ACTIONS}{error}, undef ]);

    }

    #never reached
	croak("Error in driver logic. Please, report it as a BUG");

}#_Parse
#DO NOT remove comment

1;


} ###########End of include /usr/local/share/perl/5.10.0/Parse/Eyapp/Driver.pm file

{ ###########Included /usr/local/share/perl/5.10.0/Parse/Eyapp/Node.pm file
# (c) Parse::Eyapp Copyright 2006-2007 Casiano Rodriguez-Leon, all rights reserved.
package Parse::Eyapp::Node;
use strict;
use Carp;#use base qw(Exporter);
use List::MoreUtils qw(firstval lastval);
use List::Util qw(first);
use Data::Dumper;

#our @EXPORT_OK = qw(new);

our $FILENAME=__FILE__;

####################################################################
# Usage      : 
# line: %name PROG
#        exp <%name EXP + ';'>
#                 { @{$lhs->{t}} = map { $_->{t}} ($lhs->child(0)->children()); }
# ;
# Returns    : The array of children of the node. When the tree is a
#              translation scheme the CODE references are also included
# Parameters : the node (method)
# See Also   : Children

sub children {
  my $self = CORE::shift;
  
  return () unless UNIVERSAL::can($self, 'children');
  @{$self->{children}} = @_ if @_;
  @{$self->{children}}
}

####################################################################
# Usage      :  line: %name PROG
#                        (exp) <%name EXP + ';'>
#                          { @{$lhs->{t}} = map { $_->{t}} ($_[1]->Children()); }
#
# Returns    : The true children of the node, excluding CODE CHILDREN
# Parameters : The Node object

sub Children {
  my $self = CORE::shift;
  
  return () unless UNIVERSAL::can($self, 'children');

  @{$self->{children}} = @_ if @_;
  grep { !UNIVERSAL::isa($_, 'CODE') } @{$self->{children}}
}

####################################################################
# Returns    : Last non CODE child
# Parameters : the node object

sub Last_child {
  my $self = CORE::shift;

  return unless UNIVERSAL::can($self, 'children') and @{$self->{children}};
  my $i = -1;
  $i-- while defined($self->{children}->[$i]) and UNIVERSAL::isa($self->{children}->[$i], 'CODE');
  return  $self->{children}->[$i];
}

sub last_child {
  my $self = CORE::shift;

  return unless UNIVERSAL::can($self, 'children') and @{$self->{children}};
  ${$self->{children}}[-1];
}

####################################################################
# Usage      :  $node->child($i)
#  my $transform = Parse::Eyapp::Treeregexp->new( STRING => q{
#     commutative_add: PLUS($x, ., $y, .)
#       => { my $t = $x; $_[0]->child(0, $y); $_[0]->child(2, $t)}
#  }
# Purpose    : Setter-getter to modify a specific child of a node
# Returns    : Child with index $i. Returns undef if the child does not exists
# Parameters : Method: the node and the index of the child. The new value is used 
#              as a setter.
# Throws     : Croaks if the index parameter is not provided
sub child {
  my ($self, $index, $value) = @_;
  
  #croak "$self is not a Parse::Eyapp::Node" unless $self->isa('Parse::Eyapp::Node');
  return undef unless  UNIVERSAL::can($self, 'child');
  croak "Index not provided" unless defined($index);
  $self->{children}[$index] = $value if defined($value);
  $self->{children}[$index];
}

sub descendant {
  my $self = shift;
  my $coord = shift;

  my @pos = split /\./, $coord;
  my $t = $self;
  my $x = shift(@pos); # discard the first empty dot
  for (@pos) {
      croak "Error computing descendant: $_ is not a number\n" 
    unless m{\d+} and $_ < $t->children;
    $t = $t->child($_);
  }
  return $t;
}

####################################################################
# Usage      : $node->s(@transformationlist);
# Example    : The following example simplifies arithmetic expressions
# using method "s":
# > cat Timeszero.trg
# /* Operator "and" has higher priority than comma "," */
# whatever_times_zero: TIMES(@b, NUM($x) and { $x->{attr} == 0 }) => { $_[0] = $NUM }
#
# > treereg Timeszero
# > cat arrays.pl
#  !/usr/bin/perl -w
#  use strict;
#  use Rule6;
#  use Parse::Eyapp::Treeregexp;
#  use Timeszero;
#
#  my $parser = new Rule6();
#  my $t = $parser->Run;
#  $t->s(@Timeszero::all);
#
#
# Returns    : Nothing
# Parameters : The object (is a method) and the list of transformations to apply.
#              The list may be a list of Parse::Eyapp:YATW objects and/or CODE
#              references
# Throws     : No exceptions
# Comments   : The set of transformations is repeatedly applied to the node
#              until there are no changes.
#              The function may hang if the set of transformations
#              matches forever.
# See Also   : The "s" method for Parse::Eyapp::YATW objects 
#              (i.e. transformation objects)

sub s {
  my @patterns = @_[1..$#_];

  # Make them Parse::Eyapp:YATW objects if they are CODE references
  @patterns = map { ref($_) eq 'CODE'? 
                      Parse::Eyapp::YATW->new(
                        PATTERN => $_,
                        #PATTERN_ARGS => [],
                      )
                      :
                      $_
                  } 
                  @patterns;
  my $changes; 
  do { 
    $changes = 0;
    foreach (@patterns) {
      $_->{CHANGES} = 0;
      $_->s($_[0]);
      $changes += $_->{CHANGES};
    }
  } while ($changes);
}


####################################################################
# Usage      : ????
# Purpose    : bud = Bottom Up Decoration: Decorates the tree with flowers :-)
#              The purpose is to decorate the AST with attributes during
#              the context-dependent analysis, mainly type-checking.
# Returns    : ????
# Parameters : The transformations.
# Throws     : no exceptions
# Comments   : The tree is traversed bottom-up. The set of
#              transformations is applied to each node in the order
#              supplied by the user. As soon as one succeeds
#              no more transformations are applied.
# See Also   : n/a
# To Do      : Avoid closure. Save @patterns inside the object
{
  my @patterns;

  sub bud {
    @patterns = @_[1..$#_];

    @patterns = map { ref($_) eq 'CODE'? 
                        Parse::Eyapp::YATW->new(
                          PATTERN => $_,
                          #PATTERN_ARGS => [],
                        )
                        :
                        $_
                    } 
                    @patterns;
    _bud($_[0], undef, undef);
  }

  sub _bud {
    my $node = $_[0];
    my $index = $_[2];

      # Is an odd leaf. Not actually a Parse::Eyapp::Node. Decorate it and leave
      if (!ref($node) or !UNIVERSAL::can($node, "children"))  {
        for my $p (@patterns) {
          return if $p->pattern->(
            $_[0],  # Node being visited  
            $_[1],  # Father of this node
            $index, # Index of this node in @Father->children
            $p,  # The YATW pattern object   
          );
        }
      };

      # Recursively decorate subtrees
      my $i = 0;
      for (@{$node->{children}}) {
        $_->_bud($_, $_[0], $i);
        $i++;
      }

      # Decorate the node
      #Change YATW object to be the  first argument?
      for my $p (@patterns) {
        return if $p->pattern->($_[0], $_[1], $index, $p); 
      }
  }
} # closure for @patterns

####################################################################
# Usage      : 
# @t = Parse::Eyapp::Node->new( q{TIMES(NUM(TERMINAL), NUM(TERMINAL))}, 
#      sub { 
#        our ($TIMES, @NUM, @TERMINAL);
#        $TIMES->{type}       = "binary operation"; 
#        $NUM[0]->{type}      = "int"; 
#        $NUM[1]->{type}      = "float"; 
#        $TERMINAL[1]->{attr} = 3.5; 
#      },
#    );
# Purpose    : Multi-Constructor
# Returns    : Array of pointers to the objects created
#              in scalar context a pointer to the first node
# Parameters : The class plus the string description and attribute handler

{

my %cache;

  sub m_bless {

    my $key = join "",@_;
    my $class = shift;
    return $cache{$key} if exists $cache{$key};

    my $b = bless { children => \@_}, $class;
    $cache{$key} = $b;

    return $b;
  }
}

sub _bless {
  my $class = shift;

  my $b = bless { children => \@_ }, $class;
  return $b;
}

sub hexpand {
  my $class = CORE::shift;

  my $handler = CORE::pop if ref($_[-1]) eq 'CODE';
  my $n = m_bless(@_);

  my $newnodeclass = CORE::shift;

  no strict 'refs';
  push @{$newnodeclass."::ISA"}, 'Parse::Eyapp::Node' unless $newnodeclass->isa('Parse::Eyapp::Node');

  if (defined($handler) and UNIVERSAL::isa($handler, "CODE")) {
    $handler->($n);
  }

  $n;
}

sub hnew {
  my $blesser = \&m_bless;

  return _new($blesser, @_);
}

# Regexp for a full Perl identifier
sub _new {
  my $blesser = CORE::shift;
  my $class = CORE::shift;
  local $_ = CORE::shift; # string: tree description
  my $handler = CORE::shift if ref($_[0]) eq 'CODE';


  my %classes;
  my $b;
  #TODO: Shall I receive a prefix?

  my (@stack, @index, @results, %results, @place, $open);
  while ($_) {
    #skip white spaces
    s{\A\s+}{};

    # If is a leaf is followed by parenthesis or comma or an ID
    s{\A([A-Za-z_][A-Za-z0-9_:]*)\s*([),])} 
     {$1()$2} # ... then add an empty pair of parenthesis
      and do { 
        next; 
       };

    # If is a leaf is followed by an ID
    s{\A([A-Za-z_][A-Za-z0-9_:]*)\s+([A-Za-z_])} 
     {$1()$2} # ... then add an empty pair of parenthesis
      and do { 
        next; 
       };

    # If is a leaf at the end
    s{\A([A-Za-z_][A-Za-z0-9_:]*)\s*$} 
     {$1()} # ... then add an empty pair of parenthesis
      and do { 
        $classes{$1} = 1;
        next; 
       };

    # Is an identifier
    s{\A([A-Za-z_][A-Za-z0-9_:]*)}{} 
      and do { 
        $classes{$1} = 1;
        CORE::push @stack, $1; 
        next; 
      };

    # Open parenthesis: mark the position for when parenthesis closes
    s{\A[(]}{} 
      and do { 
        my $pos = scalar(@stack);
        CORE::push @index, $pos; 
        $place[$pos] = $open++;

        # Warning! I don't know what I am doing
        next;
      };

    # Skip commas
    s{\A,}{} and next; 

    # Closing parenthesis: time to build a node
    s{\A[)]}{} and do { 
        croak "Syntax error! Closing parenthesis has no left partner!" unless @index;
        my $begin = pop @index; # check if empty!
        my @children = splice(@stack, $begin);
        my $class = pop @stack;
        croak "Syntax error! Any couple of parenthesis must be preceded by an identifier"
          unless (defined($class) and $class =~ m{^[a-zA-Z_][\w:]*$});

        $b = $blesser->($class, @children);

        CORE::push @stack, $b;
        $results[$place[$begin]] = $b;
        CORE::push @{$results{$class}}, $b;
        next; 
    }; 

    croak "Error building Parse::Eyapp::Node tree at '$_'." unless s{\A\s+}{};
  } # while
  croak "Syntax error! Open parenthesis has no right partner!" if @index;
  { 
    no strict 'refs';
    for (keys(%classes)) {
      push @{$_."::ISA"}, 'Parse::Eyapp::Node' unless $_->isa('Parse::Eyapp::Node');
    }
  }
  if (defined($handler) and UNIVERSAL::isa($handler, "CODE")) {
    $handler->(@results);
  }
  return wantarray? @results : $b;
}

sub new {
  my $blesser = \&_bless;

  _new($blesser, @_);
}

## Used by _subtree_list
#sub compute_hierarchy {
#  my @results = @{shift()};
#
#  # Compute the hierarchy
#  my $b;
#  my @r = @results;
#  while (@results) {
#    $b = pop @results;
#    my $d = $b->{depth};
#    my $f = lastval { $_->{depth} < $d} @results;
#    
#    $b->{father} = $f;
#    $b->{children} = [];
#    unshift @{$f->{children}}, $b;
#  }
#  $_->{father} = undef for @results;
#  bless $_, "Parse::Eyapp::Node::Match" for @r;
#  return  @r;
#}

# Matches

sub m {
  my $self = shift;
  my @patterns = @_ or croak "Expected a pattern!";
  croak "Error in method m of Parse::Eyapp::Node. Expected Parse::Eyapp:YATW patterns"
    unless $a = first { !UNIVERSAL::isa($_, "Parse::Eyapp:YATW") } @_;

  # array context: return all matches
  local $a = 0;
  my %index = map { ("$_", $a++) } @patterns;
  my @stack = (
    Parse::Eyapp::Node::Match->new( 
       node => $self, 
       depth => 0,  
       dewey => "", 
       patterns =>[] 
    ) 
  );
  my @results;
  do {
    my $mn = CORE::shift(@stack);
    my %n = %$mn;

    # See what patterns do match the current $node
    for my $pattern (@patterns) {
      push @{$mn->{patterns}}, $index{$pattern} if $pattern->{PATTERN}($n{node});
    } 
    my $dewey = $n{dewey};
    if (@{$mn->{patterns}}) {
      $mn->{family} = \@patterns;

      # Is at this time that I have to compute the father
      my $f = lastval { $dewey =~ m{^$_->{dewey}}} @results;
      $mn->{father} = $f;
      # ... and children
      push @{$f->{children}}, $mn if defined($f);
      CORE::push @results, $mn;
    }
    my $childdepth = $n{depth}+1;
    my $k = -1;
    CORE::unshift @stack, 
          map 
            { 
              $k++; 
              Parse::Eyapp::Node::Match->new(
                node => $_, 
                depth => $childdepth, 
                dewey => "$dewey.$k", 
                patterns => [] 
              ) 
            } $n{node}->children();
  } while (@stack);

  wantarray? @results : $results[0];
}

#sub _subtree_scalar {
#  # scalar context: return iterator
#  my $self = CORE::shift;
#  my @patterns = @_ or croak "Expected a pattern!";
#
#  # %index gives the index of $p in @patterns
#  local $a = 0;
#  my %index = map { ("$_", $a++) } @patterns;
#
#  my @stack = ();
#  my $mn = { node => $self, depth => 0, patterns =>[] };
#  my @results = ();
#
#  return sub {
#     do {
#       # See if current $node matches some patterns
#       my $d = $mn->{depth};
#       my $childdepth = $d+1;
#       # See what patterns do match the current $node
#       for my $pattern (@patterns) {
#         push @{$mn->{patterns}}, $index{$pattern} if $pattern->{PATTERN}($mn->{node});
#       } 
#
#       if (@{$mn->{patterns}}) { # matched
#         CORE::push @results, $mn;
#
#         # Compute the hierarchy
#         my $f = lastval { $_->{depth} < $d} @results;
#         $mn->{father} = $f;
#         $mn->{children} = [];
#         $mn->{family} = \@patterns;
#         unshift @{$f->{children}}, $mn if defined($f);
#         bless $mn, "Parse::Eyapp::Node::Match";
#
#         # push children in the stack
#         CORE::unshift @stack, 
#                   map { { node => $_, depth => $childdepth, patterns => [] } } 
#                                                       $mn->{node}->children();
#         $mn = CORE::shift(@stack);
#         return $results[-1];
#       }
#       # didn't match: push children in the stack
#       CORE::unshift @stack, 
#                  map { { node => $_, depth => $childdepth, patterns => [] } } 
#                                                      $mn->{node}->children();
#       $mn = CORE::shift(@stack);
#     } while ($mn); # May be the stack is empty now, but if $mn then there is a node to process
#     # reset iterator
#     my @stack = ();
#     my $mn = { node => $self, depth => 0, patterns =>[] };
#     return undef;
#   };
#}

# Factorize this!!!!!!!!!!!!!!
#sub m {
#  goto &_subtree_list if (wantarray()); 
#  goto &_subtree_scalar;
#}

####################################################################
# Usage      :   $BLOCK->delete($ASSIGN)
#                $BLOCK->delete(2)
# Purpose    : deletes the specified child of the node
# Returns    : The deleted child
# Parameters : The object plus the index or pointer to the child to be deleted
# Throws     : If the object can't do children or has no children
# See Also   : n/a

sub delete {
  my $self = CORE::shift; # The tree object
  my $child = CORE::shift; # index or pointer

  croak "Parse::Eyapp::Node::delete error, node:\n"
        .Parse::Eyapp::Node::str($self)."\ndoes not have children" 
    unless UNIVERSAL::can($self, 'children') and ($self->children()>0);
  if (ref($child)) {
    my $i = 0;
    for ($self->children()) {
      last if $_ == $child;
      $i++;
    }
    if ($i == $self->children()) {
      warn "Parse::Eyapp::Node::delete warning: node:\n".Parse::Eyapp::Node::str($self)
           ."\ndoes not have a child like:\n"
           .Parse::Eyapp::Node::str($child)
           ."\nThe node was not deleted!\n";
      return $child;
    }
    splice(@{$self->{children}}, $i, 1);
    return $child;
  }
  my $numchildren = $self->children();
  croak "Parse::Eyapp::Node::delete error: expected an index between 0 and ".
        ($numchildren-1).". Got $child" unless ($child =~ /\d+/ and $child < $numchildren);
  splice(@{$self->{children}}, $child, 1);
  return $child;
}

####################################################################
# Usage      : $BLOCK->shift
# Purpose    : deletes the first child of the node
# Returns    : The deleted child
# Parameters : The object 
# Throws     : If the object can't do children 
# See Also   : n/a

sub shift {
  my $self = CORE::shift; # The tree object

  croak "Parse::Eyapp::Node::shift error, node:\n"
       .Parse::Eyapp::Node->str($self)."\ndoes not have children" 
    unless UNIVERSAL::can($self, 'children');

  return CORE::shift(@{$self->{children}});
}

sub unshift {
  my $self = CORE::shift; # The tree object
  my $node = CORE::shift; # node to insert

  CORE::unshift @{$self->{children}}, $node;
}

sub push {
  my $self = CORE::shift; # The tree object
  #my $node = CORE::shift; # node to insert

  #CORE::push @{$self->{children}}, $node;
  CORE::push @{$self->{children}}, @_;
}

sub insert_before {
  my $self = CORE::shift; # The tree object
  my $child = CORE::shift; # index or pointer
  my $node = CORE::shift; # node to insert

  croak "Parse::Eyapp::Node::insert_before error, node:\n"
        .Parse::Eyapp::Node::str($self)."\ndoes not have children" 
    unless UNIVERSAL::can($self, 'children') and ($self->children()>0);

  if (ref($child)) {
    my $i = 0;
    for ($self->children()) {
      last if $_ == $child;
      $i++;
    }
    if ($i == $self->children()) {
      warn "Parse::Eyapp::Node::insert_before warning: node:\n"
           .Parse::Eyapp::Node::str($self)
           ."\ndoes not have a child like:\n"
           .Parse::Eyapp::Node::str($child)."\nThe node was not inserted!\n";
      return $child;
    }
    splice(@{$self->{children}}, $i, 0, $node);
    return $node;
  }
  my $numchildren = $self->children();
  croak "Parse::Eyapp::Node::insert_before error: expected an index between 0 and ".
        ($numchildren-1).". Got $child" unless ($child =~ /\d+/ and $child < $numchildren);
  splice(@{$self->{children}}, $child, 0, $node);
  return $child;
}

sub insert_after {
  my $self = CORE::shift; # The tree object
  my $child = CORE::shift; # index or pointer
  my $node = CORE::shift; # node to insert

  croak "Parse::Eyapp::Node::insert_after error, node:\n"
        .Parse::Eyapp::Node::str($self)."\ndoes not have children" 
    unless UNIVERSAL::can($self, 'children') and ($self->children()>0);

  if (ref($child)) {
    my $i = 0;
    for ($self->children()) {
      last if $_ == $child;
      $i++;
    }
    if ($i == $self->children()) {
      warn "Parse::Eyapp::Node::insert_after warning: node:\n"
           .Parse::Eyapp::Node::str($self).
           "\ndoes not have a child like:\n"
           .Parse::Eyapp::Node::str($child)."\nThe node was not inserted!\n";
      return $child;
    }
    splice(@{$self->{children}}, $i+1, 0, $node);
    return $node;
  }
  my $numchildren = $self->children();
  croak "Parse::Eyapp::Node::insert_after error: expected an index between 0 and ".
        ($numchildren-1).". Got $child" unless ($child =~ /\d+/ and $child < $numchildren);
  splice(@{$self->{children}}, $child+1, 0, $node);
  return $child;
}

{ # $match closure

  my $match;

  sub clean_tree {
    $match = pop;
    croak "clean tree: a node and code reference expected" unless (ref($match) eq 'CODE') and (@_ > 0);
    $_[0]->_clean_tree();
  }

  sub _clean_tree {
    my @children;
    
    for ($_[0]->children()) {
      next if (!defined($_) or $match->($_));
      
      $_->_clean_tree();
      CORE::push @children, $_;
    }
    $_[0]->{children} = \@children; # Bad code
  }
} # $match closure

####################################################################
# Usage      : $t->str 
# Returns    : Returns a string describing the Parse::Eyapp::Node as a term
#              i.e., s.t. like: 'PROGRAM(FUNCTION(RETURN(TERMINAL,VAR(TERMINAL))))'
our @PREFIXES = qw(Parse::Eyapp::Node::);
our $INDENT = 0; # -1 new 0 = compact, 1 = indent, 2 = indent and include Types in closing parenthesis
our $STRSEP = ',';
our $DELIMITER = '[';
our $FOOTNOTE_HEADER = "\n---------------------------\n";
our $FOOTNOTE_SEP = ")\n";
our $FOOTNOTE_LEFT = '^{';
our $FOOTNOTE_RIGHT = '}';
our $LINESEP = 4;
our $CLASS_HANDLER = sub { type($_[0]) }; # What to print to identify the node

my %match_del = (
  '[' => ']',
  '{' => '}',
  '(' => ')',
  '<' => '>'
);

my $pair;
my $footnotes = '';
my $footnote_label;

sub str {

  my @terms;

  # Consume arg only if called as a class method Parse::Eyap::Node->str($node1, $node2, ...)
  CORE::shift unless ref($_[0]);

  for (@_) {
    $footnote_label = 0;
    $footnotes = '';
    # Set delimiters for semantic values
    if (defined($DELIMITER) and exists($match_del{$DELIMITER})) {
      $pair = $match_del{$DELIMITER};
    }
    else {
      $DELIMITER = $pair = '';
    }
    CORE::push @terms,  _str($_).$footnotes;
  }
  return wantarray? @terms : $terms[0];
}  

sub _str {
  my $self = CORE::shift;          # root of the subtree
  my $indent = (CORE::shift or 0); # current depth in spaces " "

  my @children = Parse::Eyapp::Node::children($self);
  my @t;

  my $res;
  my $fn = $footnote_label;
  if ($INDENT >= 0 && UNIVERSAL::can($self, 'footnote')) {
    $res = $self->footnote; 
    $footnotes .= $FOOTNOTE_HEADER.$footnote_label++.$FOOTNOTE_SEP.$res if $res;
  }

  # recursively visit nodes
  for (@children) {
    CORE::push @t, Parse::Eyapp::Node::_str($_, $indent+2) if defined($_);
  }
  local $" = $STRSEP;
  my $class = $CLASS_HANDLER->($self);
  $class =~ s/^$_// for @PREFIXES; 
  my $information;
  $information = $self->info if ($INDENT >= 0 && UNIVERSAL::can($self, 'info'));
  $class .= $DELIMITER.$information.$pair if $information;
  if ($INDENT >= 0 &&  $res) {
   $class .= $FOOTNOTE_LEFT.$fn.$FOOTNOTE_RIGHT;
  }

  if ($INDENT > 0) {
    my $w = " "x$indent;
    $class = "\n$w$class";
    $class .= "(@t\n$w)" if @children;
    $class .= " # ".$CLASS_HANDLER->($self) if ($INDENT > 1) and ($class =~ tr/\n/\n/>$LINESEP);
  }
  else {
    $class .= "(@t)" if @children;
  }
  return $class;
}

#use overload q{""} => \&stringify;

sub translation_scheme {
  my $self = CORE::shift; # root of the subtree
  my @children = $self->children();
  for (@children) {
    if (ref($_) eq 'CODE') {
      $_->($self, $self->Children);
    }
    elsif (defined($_)) {
      translation_scheme($_);
    }
  }
}

sub type {
 my $type = ref($_[0]);

 if ($type) {
   if (defined($_[1])) {
     $type = $_[1];
     Parse::Eyapp::Driver::BeANode($type);
     bless $_[0], $type;
   }
   return $type 
 }
 return 'Parse::Eyapp::Node::STRING';
}

{ # Tree "fuzzy" equality

####################################################################
# Usage      : $t1->equal($t2, n => sub { return $_[0] == $_[1] })
# Purpose    : Checks the equality between two AST
# Returns    : 1 if equal, 0 if not 'equal'
# Parameters : Two Parse::Eyapp:Node nodes and a hash of comparison handlers.
#              The keys of the hash are the attributes of the nodes. The value is
#              a comparator function. The comparator for key $k receives the attribute
#              for the nodes being visited and rmust return true if they are considered similar
# Throws     : exceptions if the parameters aren't Parse::Eyapp::Nodes

  my %handler;

  # True if the two trees look similar
  sub equal {
    croak "Parse::Eyapp::Node::equal error. Expected two syntax trees \n" unless (@_ > 1);

    %handler = splice(@_, 2);
    my $key = '';
    defined($key=firstval {!UNIVERSAL::isa($handler{$_},'CODE') } keys %handler) 
    and 
      croak "Parse::Eyapp::Node::equal error. Expected a CODE ref for attribute $key\n";
    goto &_equal;
  }

  sub _equal {
    my $tree1 = CORE::shift;
    my $tree2 = CORE::shift;

    # Same type
    return 0 unless ref($tree1) eq ref($tree2);

    # Check attributes via handlers
    for (keys %handler) {
      # Check for existence
      return 0 if (exists($tree1->{$_}) && !exists($tree2->{$_}));
      return 0 if (exists($tree2->{$_}) && !exists($tree1->{$_}));

      # Check for definition
      return 0 if (defined($tree1->{$_}) && !defined($tree2->{$_}));
      return 0 if (defined($tree2->{$_}) && !defined($tree1->{$_}));

      # Check for equality
      return 0 unless $handler{$_}->($tree1->{$_}, $tree2->{$_});
    }

    # Same number of children
    my @children1 = @{$tree1->{children}};
    my @children2 = @{$tree2->{children}};
    return 0 unless @children1 == @children2;

    # Children must be similar
    for (@children1) {
      my $ch2 = CORE::shift @children2;
      return 0 unless _equal($_, $ch2);
    }
    return 1;
  }
}

1;

package Parse::Eyapp::Node::Match;
our @ISA = qw(Parse::Eyapp::Node);

# A Parse::Eyapp::Node::Match object is a reference
# to a tree of Parse::Eyapp::Nodes that has been used
# in a tree matching regexp. You can think of them
# as the equivalent of $1 $2, ... in treeregexeps

# The depth of the Parse::Eyapp::Node being referenced

sub new {
  my $class = shift;

  my $matchnode = { @_ };
  $matchnode->{children} = [];
  bless $matchnode, $class;
}

sub depth {
  my $self = shift;

  return $self->{depth};
}

# The coordinates of the Parse::Eyapp::Node being referenced
sub coord {
  my $self = shift;

  return $self->{dewey};
}


# The Parse::Eyapp::Node being referenced
sub node {
  my $self = shift;

  return $self->{node};
}

# The Parse::Eyapp::Node:Match that references
# the nearest ancestor of $self->{node} that matched
sub father {
  my $self = shift;

  return $self->{father};
}
  
# The patterns that matched with $self->{node}
# Indexes
sub patterns {
  my $self = shift;

  @{$self->{patterns}} = @_ if @_;
  return @{$self->{patterns}};
}
  
# The original list of patterns that produced this match
sub family {
  my $self = shift;

  @{$self->{family}} = @_ if @_;
  return @{$self->{family}};
}
  
# The names of the patterns that matched
sub names {
  my $self = shift;

  my @indexes = $self->patterns;
  my @family = $self->family;

  return map { $_->{NAME} or "Unknown" } @family[@indexes];
}
  
sub info {
  my $self = shift;

  my $node = $self->node;
  my @names = $self->names;
  my $nodeinfo;
  if (UNIVERSAL::can($node, 'info')) {
    $nodeinfo = ":".$node->info;
  }
  else {
    $nodeinfo = "";
  }
  return "[".ref($self->node).":".$self->depth.":@names$nodeinfo]"
}

1;



} ###########End of include /usr/local/share/perl/5.10.0/Parse/Eyapp/Node.pm file

{ ###########Included /usr/local/share/perl/5.10.0/Parse/Eyapp/YATW.pm file
# (c) Parse::Eyapp Copyright 2006 Casiano Rodriguez-Leon, all rights reserved.
package Parse::Eyapp::YATW;
use strict;
use warnings;
use Carp;
use Data::Dumper;
use List::Util qw(first);
use List::MoreUtils qw(lastval);
#use Parse::Eyapp::Base qw( valid_keys invalid_keys );

sub valid_keys {
  my %valid_args = @_;

  my @valid_args = keys(%valid_args); 
  local $" = ", "; 
  return "@valid_args" 
}

sub invalid_keys {
  my $valid_args = shift;
  my $args = shift;

  return (first { !exists($valid_args->{$_}) } keys(%$args));
}


our $VERSION = $Parse::Eyapp::Driver::VERSION;

our $FILENAME=__FILE__;

# TODO: Check args. Typical args:
# 'CHANGES' => 0,
# 'PATTERN' => sub { "DUMMY" },
# 'NAME' => 'fold',
# 'PATTERN_ARGS' => [],
# 'PENDING_TASKS' => {},
# 'NODE' => []

my %_new_yatw = (
  PATTERN => 'CODE',
  NAME => 'STRING',
);

my $validkeys = valid_keys(%_new_yatw); 

sub new {
  my $class = shift;
  my %args = @_;

  croak "Error. Expected a code reference when building a tree walker. " unless (ref($args{PATTERN}) eq 'CODE');
  if (defined($a = invalid_keys(\%_new_yatw, \%args))) {
    croak("Parse::Eyapp::YATW::new Error!: unknown argument $a. Valid arguments are: $validkeys")
  }


  # obsolete, I have to delete this
  #$args{PATTERN_ARGS} = [] unless (ref($args{PATTERN_ARGS}) eq 'ARRAY'); 

  # Internal fields

  # Tell us if the node has changed after the visit
  $args{CHANGES} = 0;
  
  # PENDING_TASKS is a queue storing the tasks waiting for a "safe time/node" to do them 
  # Usually that time occurs when visiting the father of the node who generated the job 
  # (when asap criteria is applied).
  # Keys are node references. Values are array references. Each entry defines:
  #  [ the task kind, the node where to do the job, and info related to the particular job ]
  # Example: @{$self->{PENDING_TASKS}{$father}}, ['insert_before', $node, ${$self->{NODE}}[0] ];
  $args{PENDING_TASKS} = {};

  # NODE is a stack storing the ancestor of the node being visited
  # Example: my $ancestor = ${$self->{NODE}}[$k]; when k=1 is the father, k=2 the grandfather, etc.
  # Example: CORE::unshift @{$self->{NODE}}, $_[0]; Finished the visit so take it out
  $args{NODE} = [];

  bless \%args, $class;
}

sub buildpatterns {
  my $class = shift;
  
  my @family;
  while (my ($n, $p) = splice(@_, 0,2)) {
    push @family, Parse::Eyapp::YATW->new(NAME => $n, PATTERN => $p);
  }
  return wantarray? @family : $family[0];
}

####################################################################
# Usage      : @r = $b{$_}->m($t)
#              See Simple4.eyp and m_yatw.pl in the examples directory
# Returns    : Returns an array of nodes matching the treeregexp
#              The set of nodes is a Parse::Eyapp::Node::Match tree 
#              showing the relation between the matches
# Parameters : The tree (and the object of course)
# depth is no longer used: eliminate
sub m {
  my $p = shift(); # pattern YATW object
  my $t = shift;   # tree
  my $pattern = $p->{PATTERN}; # CODE ref

  # References to the found nodes are stored in @stack
  my @stack = ( Parse::Eyapp::Node::Match->new(node=>$t, depth=>0, dewey => "") ); 
  my @results;
  do {
    my $n = CORE::shift(@stack);
    my %n = %$n;

    my $dewey = $n->{dewey};
    my $d = $n->{depth};
    if ($pattern->($n{node})) {
      $n->{family} = [ $p ];
      $n->{patterns} = [ 0 ];

      # Is at this time that I have to compute the father
      my $f = lastval { $dewey =~ m{^$_->{dewey}}} @results;
      $n->{father} = $f;
      # ... and children
      push @{$f->{children}}, $n if defined($f);
      push @results, $n;
    }
    my $k = 0;
    CORE::unshift @stack, 
       map { 
              local $a;
              $a = Parse::Eyapp::Node::Match->new(node=>$_, depth=>$d+1, dewey=>"$dewey.$k" );
              $k++;
              $a;
           } $n{node}->children();
  } while (@stack);

  return wantarray? @results : $results[0];
}

######################### getter-setter for YATW objects ###########################

sub pattern {
  my $self = shift;
  $self->{PATTERN} = shift if (@_);
  return $self->{PATTERN};
}

sub name {
  my $self = shift;
  $self->{NAME} = shift if (@_);
  return $self->{NAME};
}

#sub pattern_args {
#  my $self = shift;
#
#  $self->{PATTERN_ARGS} = @_ if @_;
#  return @{$self->{PATTERN_ARGS}};
#}

########################## PENDING TASKS management ################################

# Purpose    : Deletes the node that matched from the list of children of its father. 
sub delete {
  my $self = shift;

  bless $self->{NODE}[0], 'Parse::Eyapp::Node::DELETE';
}
  
sub make_delete_effective {
  my $self = shift;
  my $node = shift;

  my $i = -1+$node->children;
  while ($i >= 0) {
    if (UNIVERSAL::isa($node->child($i), 'Parse::Eyapp::Node::DELETE')) {
      $self->{CHANGES}++ if splice @{$node->{children}}, $i, 1;
    }
    $i--;
  }
}

####################################################################
# Usage      :    my $b = Parse::Eyapp::Node->new( 'NUM(TERMINAL)', sub { $_[1]->{attr} = 4 });
#                 $yatw_pattern->unshift($b); 
# Parameters : YATW object, node to insert, 
#              ancestor offset: 0 = root of the tree that matched, 1 = father, 2 = granfather, etc.

sub unshift {
  my ($self, $node, $k) = @_;
  $k = 1 unless defined($k); # father by default

  my $ancestor = ${$self->{NODE}}[$k];
  croak "unshift: does not exist ancestor $k of node ".Dumper(${$self->{NODE}}[0]) unless defined($ancestor);

  # Stringification of $ancestor. Hope it works
                                            # operation, node to insert, 
  push @{$self->{PENDING_TASKS}{$ancestor}}, ['unshift', $node ];
}

sub insert_before {
  my ($self, $node) = @_;

  my $father = ${$self->{NODE}}[1];
  croak "insert_before: does not exist father of node ".Dumper(${$self->{NODE}}[0]) unless defined($father);

                                           # operation, node to insert, before this node 
  push @{$self->{PENDING_TASKS}{$father}}, ['insert_before', $node, ${$self->{NODE}}[0] ];
}

sub _delayed_insert_before {
  my ($father, $node, $before) = @_;

  my $i = 0;
  for ($father->children()) {
    last if ($_ == $before);
    $i++;
  }
  splice @{$father->{children}}, $i, 0, $node;
}

sub do_pending_tasks {
  my $self = shift;
  my $node = shift;

  my $mytasks = $self->{PENDING_TASKS}{$node};
  while ($mytasks and (my $job = shift @{$mytasks})) {
    my @args = @$job;
    my $task = shift @args;

    # change this for a jump table
    if ($task eq 'unshift') {
      CORE::unshift(@{$node->{children}}, @args);
      $self->{CHANGES}++;
    }
    elsif ($task eq 'insert_before') {
      _delayed_insert_before($node, @args);
      $self->{CHANGES}++;
    }
  }
}

####################################################################
# Parameters : pattern, node, father of the node, index of the child in the children array
# YATW object. Probably too many 
sub s {
  my $self = shift;
  my $node = $_[0] or croak("Error. Method __PACKAGE__::s requires a node");
  CORE::unshift @{$self->{NODE}}, $_[0];
  # father is $_[1]
  my $index = $_[2];

  # If is not a reference or can't children then simply check the matching and leave
  if (!ref($node) or !UNIVERSAL::can($node, "children"))  {
                                         
    $self->{CHANGES}++ if $self->pattern->(
      $_[0],  # Node being visited  
      $_[1],  # Father of this node
      $index, # Index of this node in @Father->children
      $self,  # The YATW pattern object   
    );
    return;
  };
  
  # Else, is not a leaf and is a regular Parse::Eyapp::Node
  # Recursively transform subtrees
  my $i = 0;
  for (@{$node->{children}}) {
    $self->s($_, $_[0], $i);
    $i++;
  }
  
  my $number_of_changes = $self->{CHANGES};
  # Now is safe to delete children nodes that are no longer needed
  $self->make_delete_effective($node);

  # Safely do pending jobs for this node
  $self->do_pending_tasks($node);

  #node , father, childindex, and ... 
  #Change YATW object to be the  first argument?
  if ($self->pattern->($_[0], $_[1], $index, $self)) {
    $self->{CHANGES}++;
  }
  shift @{$self->{NODE}};
}

1;


} ###########End of include /usr/local/share/perl/5.10.0/Parse/Eyapp/YATW.pm file


#line 32 "src/sh.yp"

# Initialization

no warnings 'redefine';

# Operators:
our %operators = qw(
        &&  AND_IF
        ||  OR_IF
        ;;  DSEMI
        <<  DLESS
        >>  DGREAT
        <&  LESSAND
        >&  GREATAND
        <>  LESSGREAT
        <<- DLESSDASH
        >|  CLOBBER
        
        &>  ANDGREAT
        <<< TLESS
    );

# Reserved words are words that have special meaning to the shell;
# The following words shall be recognized as reserved words:
our %reserved = qw(
        if     If
        then   Then
        else   Else
        elif   Elif
        fi     Fi
        do     Do
        done   Done
        case   Case
        esac   Esac
        while  While
        until  Until
        for    For
        {      Lbrace
        }      Rbrace
        !      Bang
        in     In
        
        function Function
        select   Select
    );

#line 2175 ShParser.pm

my $warnmessage =<< "EOFWARN";
Warning!: Did you changed the \@ShParser::ISA variable inside the header section of the eyapp program?
EOFWARN

sub new {
        my($class)=shift;
        ref($class)
    and $class=ref($class);

    warn $warnmessage unless __PACKAGE__->isa('Parse::Eyapp::Driver'); 
    my($self)=$class->SUPER::new( yyversion => '1.109',
                                  yyGRAMMAR  =>
[
  [ _SUPERSTART => '$start', [ 'start', '$end' ], 0 ],
  [ start_1 => 'start', [ 'linebreak', 'start_1' ], 0 ],
  [ start_1_2 => 'start_1', [ 'list' ], 0 ],
  [ start_1_3 => 'start_1', [ 'complete_command', 'start_1' ], 0 ],
  [ start_1_4 => 'start_1', [  ], 0 ],
  [ complete_command_5 => 'complete_command', [ 'list', 'separator' ], 0 ],
  [ complete_command_6 => 'complete_command', [ 'error', 'separator' ], 0 ],
  [ list_7 => 'list', [ 'list', 'separator_op', 'and_or' ], 0 ],
  [ list_8 => 'list', [ 'and_or' ], 0 ],
  [ and_or_9 => 'and_or', [ 'pipeline' ], 0 ],
  [ and_or_10 => 'and_or', [ 'and_or', 'AND_IF', 'linebreak', 'pipeline' ], 0 ],
  [ and_or_11 => 'and_or', [ 'and_or', 'OR_IF', 'linebreak', 'pipeline' ], 0 ],
  [ pipeline_12 => 'pipeline', [ 'pipe_sequence' ], 0 ],
  [ pipeline_13 => 'pipeline', [ 'Bang', 'pipe_sequence' ], 0 ],
  [ pipe_sequence_14 => 'pipe_sequence', [ 'command' ], 0 ],
  [ pipe_sequence_15 => 'pipe_sequence', [ 'pipe_sequence', '|', 'linebreak', 'command' ], 0 ],
  [ command_16 => 'command', [ 'simple_command' ], 0 ],
  [ command_17 => 'command', [ 'compound_command' ], 0 ],
  [ command_18 => 'command', [ 'compound_command', 'redirect_list' ], 0 ],
  [ command_19 => 'command', [ 'function_definition' ], 0 ],
  [ command_20 => 'command', [ 'dbracket' ], 0 ],
  [ compound_command_21 => 'compound_command', [ 'brace_group' ], 0 ],
  [ compound_command_22 => 'compound_command', [ 'subshell' ], 0 ],
  [ compound_command_23 => 'compound_command', [ 'for_clause' ], 0 ],
  [ compound_command_24 => 'compound_command', [ 'case_clause' ], 0 ],
  [ compound_command_25 => 'compound_command', [ 'if_clause' ], 0 ],
  [ compound_command_26 => 'compound_command', [ 'while_clause' ], 0 ],
  [ compound_command_27 => 'compound_command', [ 'until_clause' ], 0 ],
  [ compound_command_28 => 'compound_command', [ 'select_clause' ], 0 ],
  [ subshell_29 => 'subshell', [ '(', 'compound_list', ')' ], 0 ],
  [ compound_list_30 => 'compound_list', [ 'term' ], 0 ],
  [ compound_list_31 => 'compound_list', [ 'newline_list', 'term' ], 0 ],
  [ compound_list_32 => 'compound_list', [ 'term', 'separator' ], 0 ],
  [ compound_list_33 => 'compound_list', [ 'newline_list', 'term', 'separator' ], 0 ],
  [ term_34 => 'term', [ 'term', 'separator', 'and_or' ], 0 ],
  [ term_35 => 'term', [ 'and_or' ], 0 ],
  [ select_clause_36 => 'select_clause', [ 'Select', 'name', 'linebreak', 'do_group' ], 0 ],
  [ select_clause_37 => 'select_clause', [ 'Select', 'name', 'linebreak', 'in', 'wordlist', 'sequential_sep', 'do_group' ], 0 ],
  [ _OPTIONAL => 'OPTIONAL-1', [ 'sequential_sep' ], 0 ],
  [ _OPTIONAL => 'OPTIONAL-1', [  ], 0 ],
  [ for_clause_40 => 'for_clause', [ 'For', 'name', 'linebreak', 'do_group' ], 0 ],
  [ for_clause_41 => 'for_clause', [ 'For', 'name', 'sequential_sep', 'do_group' ], 0 ],
  [ for_clause_42 => 'for_clause', [ 'For', 'name', 'linebreak', 'in', 'sequential_sep', 'do_group' ], 0 ],
  [ for_clause_43 => 'for_clause', [ 'For', 'name', 'linebreak', 'in', 'wordlist', 'sequential_sep', 'do_group' ], 0 ],
  [ for_clause_44 => 'for_clause', [ 'For', '((', 'expression', '))', 'OPTIONAL-1', 'do_group' ], 0 ],
  [ name_45 => 'name', [ 'NAME' ], 0 ],
  [ in_46 => 'in', [ 'In' ], 0 ],
  [ wordlist_47 => 'wordlist', [ 'wordlist', 'WORD' ], 0 ],
  [ wordlist_48 => 'wordlist', [ 'WORD' ], 0 ],
  [ case_clause_49 => 'case_clause', [ 'Case', 'WORD', 'linebreak', 'in', 'linebreak', 'case_list', 'Esac' ], 0 ],
  [ case_clause_50 => 'case_clause', [ 'Case', 'WORD', 'linebreak', 'in', 'linebreak', 'case_list_ns', 'Esac' ], 0 ],
  [ case_clause_51 => 'case_clause', [ 'Case', 'WORD', 'linebreak', 'in', 'linebreak', 'Esac' ], 0 ],
  [ case_list_ns_52 => 'case_list_ns', [ 'case_list', 'case_item_ns' ], 0 ],
  [ case_list_ns_53 => 'case_list_ns', [ 'case_item_ns' ], 0 ],
  [ case_list_54 => 'case_list', [ 'case_list', 'case_item' ], 0 ],
  [ case_list_55 => 'case_list', [ 'case_item' ], 0 ],
  [ case_item_ns_56 => 'case_item_ns', [ 'pattern_list', ')', 'linebreak' ], 0 ],
  [ case_item_ns_57 => 'case_item_ns', [ 'pattern_list', ')', 'compound_list', 'linebreak' ], 0 ],
  [ case_item_ns_58 => 'case_item_ns', [ '(', 'pattern_list', ')', 'linebreak' ], 0 ],
  [ case_item_ns_59 => 'case_item_ns', [ '(', 'pattern_list', ')', 'compound_list', 'linebreak' ], 0 ],
  [ case_item_60 => 'case_item', [ 'pattern_list', ')', 'linebreak', 'DSEMI', 'linebreak' ], 0 ],
  [ case_item_61 => 'case_item', [ 'pattern_list', ')', 'compound_list', 'DSEMI', 'linebreak' ], 0 ],
  [ case_item_62 => 'case_item', [ '(', 'pattern_list', ')', 'linebreak', 'DSEMI', 'linebreak' ], 0 ],
  [ case_item_63 => 'case_item', [ '(', 'pattern_list', ')', 'compound_list', 'DSEMI', 'linebreak' ], 0 ],
  [ pattern_64 => 'pattern', [ 'WORD' ], 0 ],
  [ pattern_65 => 'pattern', [ '(', 'pattern_list', ')' ], 0 ],
  [ pattern_66 => 'pattern', [ 'pattern', 'pattern' ], 0 ],
  [ pattern_list_67 => 'pattern_list', [ 'pattern' ], 0 ],
  [ pattern_list_68 => 'pattern_list', [ 'pattern', '|', 'pattern' ], 0 ],
  [ if_clause_69 => 'if_clause', [ 'If', 'compound_list', 'Then', 'compound_list', 'else_part', 'Fi' ], 0 ],
  [ if_clause_70 => 'if_clause', [ 'If', 'compound_list', 'Then', 'compound_list', 'Fi' ], 0 ],
  [ if_clause_71 => 'if_clause', [ 'If', 'dparenthesis', 'sequential_sep', 'Then', 'compound_list', 'else_part', 'Fi' ], 0 ],
  [ if_clause_72 => 'if_clause', [ 'If', 'dparenthesis', 'sequential_sep', 'Then', 'compound_list', 'Fi' ], 0 ],
  [ else_part_73 => 'else_part', [ 'Elif', 'compound_list', 'Then', 'compound_list' ], 0 ],
  [ else_part_74 => 'else_part', [ 'Elif', 'compound_list', 'Then', 'compound_list', 'else_part' ], 0 ],
  [ else_part_75 => 'else_part', [ 'Else', 'compound_list' ], 0 ],
  [ dbracket_76 => 'dbracket', [ '[[', 'expression', ']]' ], 0 ],
  [ dparenthesis_77 => 'dparenthesis', [ '((', 'expression', '))' ], 0 ],
  [ expression_78 => 'expression', [ 'WORD' ], 0 ],
  [ expression_79 => 'expression', [ 'linebreak' ], 0 ],
  [ expression_80 => 'expression', [ 'expression', 'WORD' ], 0 ],
  [ expression_81 => 'expression', [ 'expression', 'linebreak' ], 0 ],
  [ while_clause_82 => 'while_clause', [ 'While', 'compound_list', 'do_group' ], 0 ],
  [ while_clause_83 => 'while_clause', [ 'While', 'dparenthesis', 'sequential_sep', 'do_group' ], 0 ],
  [ until_clause_84 => 'until_clause', [ 'Until', 'compound_list', 'do_group' ], 0 ],
  [ until_clause_85 => 'until_clause', [ 'Until', 'dparenthesis', 'sequential_sep', 'do_group' ], 0 ],
  [ function_definition_86 => 'function_definition', [ 'Function', 'fname', '(', ')', 'linebreak', 'function_body' ], 0 ],
  [ function_definition_87 => 'function_definition', [ 'Function', 'fname', 'linebreak', 'function_body' ], 0 ],
  [ function_definition_88 => 'function_definition', [ 'fname', '(', ')', 'linebreak', 'function_body' ], 0 ],
  [ function_body_89 => 'function_body', [ 'compound_command' ], 0 ],
  [ function_body_90 => 'function_body', [ 'compound_command', 'redirect_list' ], 0 ],
  [ fname_91 => 'fname', [ 'NAME' ], 0 ],
  [ brace_group_92 => 'brace_group', [ 'Lbrace', 'compound_list', 'Rbrace' ], 0 ],
  [ do_group_93 => 'do_group', [ 'Do', 'compound_list', 'Done' ], 0 ],
  [ simple_command_94 => 'simple_command', [ 'cmd_prefix', 'cmd_word', 'cmd_suffix' ], 0 ],
  [ simple_command_95 => 'simple_command', [ 'cmd_prefix', 'cmd_word' ], 0 ],
  [ simple_command_96 => 'simple_command', [ 'cmd_prefix' ], 0 ],
  [ simple_command_97 => 'simple_command', [ 'cmd_name', 'cmd_suffix' ], 0 ],
  [ simple_command_98 => 'simple_command', [ 'cmd_name' ], 0 ],
  [ cmd_name_99 => 'cmd_name', [ 'WORD' ], 0 ],
  [ cmd_word_100 => 'cmd_word', [ 'WORD' ], 0 ],
  [ cmd_prefix_101 => 'cmd_prefix', [ 'io_redirect' ], 0 ],
  [ cmd_prefix_102 => 'cmd_prefix', [ 'cmd_prefix', 'io_redirect' ], 0 ],
  [ cmd_prefix_103 => 'cmd_prefix', [ 'ASSIGNMENT_WORD' ], 0 ],
  [ cmd_prefix_104 => 'cmd_prefix', [ 'cmd_prefix', 'ASSIGNMENT_WORD' ], 0 ],
  [ cmd_suffix_105 => 'cmd_suffix', [ 'io_redirect' ], 0 ],
  [ cmd_suffix_106 => 'cmd_suffix', [ 'cmd_suffix', 'io_redirect' ], 0 ],
  [ cmd_suffix_107 => 'cmd_suffix', [ 'WORD' ], 0 ],
  [ cmd_suffix_108 => 'cmd_suffix', [ 'cmd_suffix', 'WORD' ], 0 ],
  [ redirect_list_109 => 'redirect_list', [ 'io_redirect' ], 0 ],
  [ redirect_list_110 => 'redirect_list', [ 'redirect_list', 'io_redirect' ], 0 ],
  [ io_redirect_111 => 'io_redirect', [ 'io_file' ], 0 ],
  [ io_redirect_112 => 'io_redirect', [ 'IO_NUMBER', 'io_file' ], 0 ],
  [ io_redirect_113 => 'io_redirect', [ 'io_here' ], 0 ],
  [ io_redirect_114 => 'io_redirect', [ 'IO_NUMBER', 'io_here' ], 0 ],
  [ io_redirect_115 => 'io_redirect', [ 'ANDGREAT', 'filename' ], 0 ],
  [ io_redirect_116 => 'io_redirect', [ 'TLESS', 'WORD' ], 0 ],
  [ io_file_117 => 'io_file', [ '<', 'filename' ], 0 ],
  [ io_file_118 => 'io_file', [ 'LESSAND', 'filename' ], 0 ],
  [ io_file_119 => 'io_file', [ '>', 'filename' ], 0 ],
  [ io_file_120 => 'io_file', [ 'GREATAND', 'filename' ], 0 ],
  [ io_file_121 => 'io_file', [ 'DGREAT', 'filename' ], 0 ],
  [ io_file_122 => 'io_file', [ 'LESSGREAT', 'filename' ], 0 ],
  [ io_file_123 => 'io_file', [ 'CLOBBER', 'filename' ], 0 ],
  [ io_file_124 => 'io_file', [ '<', '<(', 'term', ')' ], 0 ],
  [ io_file_125 => 'io_file', [ '>', '>(', 'term', ')' ], 0 ],
  [ filename_126 => 'filename', [ 'WORD' ], 0 ],
  [ io_here_127 => 'io_here', [ 'DLESS', 'here_end' ], 0 ],
  [ io_here_128 => 'io_here', [ 'DLESSDASH', 'here_end' ], 0 ],
  [ here_end_129 => 'here_end', [ 'WORD' ], 0 ],
  [ newline_list_130 => 'newline_list', [ 'NEWLINE' ], 0 ],
  [ newline_list_131 => 'newline_list', [ 'newline_list', 'NEWLINE' ], 0 ],
  [ linebreak_132 => 'linebreak', [ 'newline_list' ], 0 ],
  [ linebreak_133 => 'linebreak', [  ], 0 ],
  [ separator_op_134 => 'separator_op', [ '&' ], 0 ],
  [ separator_op_135 => 'separator_op', [ ';' ], 0 ],
  [ separator_136 => 'separator', [ 'separator_op', 'linebreak' ], 0 ],
  [ separator_137 => 'separator', [ 'newline_list' ], 0 ],
  [ sequential_sep_138 => 'sequential_sep', [ ';', 'linebreak' ], 0 ],
  [ sequential_sep_139 => 'sequential_sep', [ 'newline_list' ], 0 ],
  [ NAME_140 => 'NAME', [ 'WORD' ], 0 ],
  [ ASSIGNMENT_WORD_141 => 'ASSIGNMENT_WORD', [ 'WORD' ], 0 ],
],
                                  yyTERMS  =>
{ '$end' => 0, '&' => 0, '(' => 0, '((' => 0, ')' => 0, '))' => 0, ';' => 0, '<' => 0, '<(' => 0, '>' => 0, '>(' => 0, '[[' => 0, ']]' => 0, '|' => 0, ANDGREAT => 1, AND_IF => 1, Bang => 1, CLOBBER => 1, Case => 1, DGREAT => 1, DLESS => 1, DLESSDASH => 1, DSEMI => 1, Do => 1, Done => 1, Elif => 1, Else => 1, Esac => 1, Fi => 1, For => 1, Function => 1, GREATAND => 1, IO_NUMBER => 1, If => 1, In => 1, LESSAND => 1, LESSGREAT => 1, Lbrace => 1, NEWLINE => 1, OR_IF => 1, Rbrace => 1, Select => 1, TLESS => 1, Then => 1, Until => 1, WORD => 1, While => 1, error => 1 },
                                  yyFILENAME  => "src/sh.yp",
                                  yystates =>
[
	{#State 0
		ACTIONS => {
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 1,
			'newline_list' => 2,
			'start' => 4
		}
	},
	{#State 1
		ACTIONS => {
			'' => -4,
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'error' => 42,
			'Select' => 44,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'subshell' => 34,
			'compound_command' => 33,
			'io_file' => 32,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'start_1' => 35,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'complete_command' => 43,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'list' => 19,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'while_clause' => 55,
			'and_or' => 54
		}
	},
	{#State 2
		ACTIONS => {
			'NEWLINE' => 57
		},
		DEFAULT => -132
	},
	{#State 3
		DEFAULT => -130
	},
	{#State 4
		ACTIONS => {
			'' => 58
		}
	},
	{#State 5
		ACTIONS => {
			"(" => -140
		},
		DEFAULT => -99
	},
	{#State 6
		DEFAULT => -24
	},
	{#State 7
		ACTIONS => {
			'WORD' => 59,
			"<(" => 61
		},
		GOTOS => {
			'filename' => 60
		}
	},
	{#State 8
		DEFAULT => -103
	},
	{#State 9
		DEFAULT => -101
	},
	{#State 10
		DEFAULT => -20
	},
	{#State 11
		ACTIONS => {
			"(" => 62
		}
	},
	{#State 12
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 3,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			"((" => 66,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'newline_list' => 63,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 65,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'compound_list' => 64,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'dparenthesis' => 67,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 13
		ACTIONS => {
			'WORD' => 69
		},
		GOTOS => {
			'NAME' => 49,
			'fname' => 70
		}
	},
	{#State 14
		DEFAULT => -21
	},
	{#State 15
		ACTIONS => {
			'WORD' => 71
		}
	},
	{#State 16
		ACTIONS => {
			'DLESS' => 47,
			'LESSAND' => 20,
			"<" => 7,
			'CLOBBER' => 24,
			'GREATAND' => 26,
			'DLESSDASH' => 25,
			'LESSGREAT' => 36,
			'DGREAT' => 52,
			">" => 29
		},
		GOTOS => {
			'io_here' => 73,
			'io_file' => 72
		}
	},
	{#State 17
		DEFAULT => -19
	},
	{#State 18
		DEFAULT => -9
	},
	{#State 19
		ACTIONS => {
			";" => 76,
			"&" => 77,
			'NEWLINE' => 3
		},
		DEFAULT => -2,
		GOTOS => {
			'newline_list' => 74,
			'separator' => 78,
			'separator_op' => 75
		}
	},
	{#State 20
		ACTIONS => {
			'WORD' => 59
		},
		GOTOS => {
			'filename' => 79
		}
	},
	{#State 21
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 3,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'newline_list' => 63,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 65,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'compound_list' => 80,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 22
		ACTIONS => {
			'WORD' => 81
		}
	},
	{#State 23
		DEFAULT => -23
	},
	{#State 24
		ACTIONS => {
			'WORD' => 59
		},
		GOTOS => {
			'filename' => 82
		}
	},
	{#State 25
		ACTIONS => {
			'WORD' => 83
		},
		GOTOS => {
			'here_end' => 84
		}
	},
	{#State 26
		ACTIONS => {
			'WORD' => 59
		},
		GOTOS => {
			'filename' => 85
		}
	},
	{#State 27
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 3,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'newline_list' => 63,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 65,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'compound_list' => 86,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 28
		DEFAULT => -27
	},
	{#State 29
		ACTIONS => {
			'WORD' => 59,
			">(" => 87
		},
		GOTOS => {
			'filename' => 88
		}
	},
	{#State 30
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 3,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			"((" => 66,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'newline_list' => 63,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 65,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'compound_list' => 89,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'dparenthesis' => 90,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 31
		ACTIONS => {
			'WORD' => 59
		},
		GOTOS => {
			'filename' => 91
		}
	},
	{#State 32
		DEFAULT => -111
	},
	{#State 33
		ACTIONS => {
			'ANDGREAT' => 31,
			"<" => 7,
			'LESSGREAT' => 36,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'LESSAND' => 20,
			'DLESS' => 47,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			'DGREAT' => 52,
			">" => 29
		},
		DEFAULT => -17,
		GOTOS => {
			'io_here' => 37,
			'io_file' => 32,
			'io_redirect' => 92,
			'redirect_list' => 93
		}
	},
	{#State 34
		DEFAULT => -22
	},
	{#State 35
		DEFAULT => -1
	},
	{#State 36
		ACTIONS => {
			'WORD' => 59
		},
		GOTOS => {
			'filename' => 94
		}
	},
	{#State 37
		DEFAULT => -113
	},
	{#State 38
		DEFAULT => -16
	},
	{#State 39
		DEFAULT => -25
	},
	{#State 40
		ACTIONS => {
			'WORD' => 95,
			'ANDGREAT' => 31,
			"<" => 7,
			'LESSGREAT' => 36,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'LESSAND' => 20,
			'DLESS' => 47,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			'DGREAT' => 52,
			">" => 29
		},
		DEFAULT => -96,
		GOTOS => {
			'io_here' => 37,
			'io_file' => 32,
			'io_redirect' => 97,
			'ASSIGNMENT_WORD' => 96,
			'cmd_word' => 98
		}
	},
	{#State 41
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 3,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			"((" => 66,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'newline_list' => 63,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 65,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'compound_list' => 99,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'dparenthesis' => 100,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 42
		ACTIONS => {
			";" => 76,
			"&" => 77,
			'NEWLINE' => 3
		},
		GOTOS => {
			'newline_list' => 74,
			'separator' => 102,
			'separator_op' => 101
		}
	},
	{#State 43
		ACTIONS => {
			'' => -4,
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'error' => 42,
			'Select' => 44,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'start_1' => 103,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'complete_command' => 43,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'list' => 19,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 54,
			'while_clause' => 55
		}
	},
	{#State 44
		ACTIONS => {
			'WORD' => 69
		},
		GOTOS => {
			'NAME' => 105,
			'name' => 104
		}
	},
	{#State 45
		DEFAULT => -14
	},
	{#State 46
		ACTIONS => {
			"|" => 106
		},
		DEFAULT => -12
	},
	{#State 47
		ACTIONS => {
			'WORD' => 83
		},
		GOTOS => {
			'here_end' => 107
		}
	},
	{#State 48
		ACTIONS => {
			'WORD' => 108,
			'ANDGREAT' => 31,
			"<" => 7,
			'LESSGREAT' => 36,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'LESSAND' => 20,
			'DLESS' => 47,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			'DGREAT' => 52,
			">" => 29
		},
		DEFAULT => -98,
		GOTOS => {
			'io_here' => 37,
			'io_file' => 32,
			'io_redirect' => 109,
			'cmd_suffix' => 110
		}
	},
	{#State 49
		DEFAULT => -91
	},
	{#State 50
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'function_definition' => 17,
			'pipe_sequence' => 111,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'while_clause' => 55
		}
	},
	{#State 51
		DEFAULT => -28
	},
	{#State 52
		ACTIONS => {
			'WORD' => 59
		},
		GOTOS => {
			'filename' => 112
		}
	},
	{#State 53
		ACTIONS => {
			'WORD' => 114,
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 113,
			'newline_list' => 2,
			'expression' => 115
		}
	},
	{#State 54
		ACTIONS => {
			'OR_IF' => 116,
			'AND_IF' => 117
		},
		DEFAULT => -8
	},
	{#State 55
		DEFAULT => -26
	},
	{#State 56
		ACTIONS => {
			'WORD' => 69,
			"((" => 119
		},
		GOTOS => {
			'NAME' => 105,
			'name' => 118
		}
	},
	{#State 57
		DEFAULT => -131
	},
	{#State 58
		DEFAULT => 0
	},
	{#State 59
		DEFAULT => -126
	},
	{#State 60
		DEFAULT => -117
	},
	{#State 61
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 120,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 62
		ACTIONS => {
			")" => 121
		}
	},
	{#State 63
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 57,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 122,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 64
		ACTIONS => {
			'Do' => 124
		},
		GOTOS => {
			'do_group' => 123
		}
	},
	{#State 65
		ACTIONS => {
			";" => 76,
			"&" => 77,
			'NEWLINE' => 3
		},
		DEFAULT => -30,
		GOTOS => {
			'newline_list' => 74,
			'separator' => 125,
			'separator_op' => 101
		}
	},
	{#State 66
		ACTIONS => {
			'WORD' => 114,
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 113,
			'newline_list' => 2,
			'expression' => 126
		}
	},
	{#State 67
		ACTIONS => {
			";" => 128,
			'NEWLINE' => 3
		},
		GOTOS => {
			'newline_list' => 127,
			'sequential_sep' => 129
		}
	},
	{#State 68
		ACTIONS => {
			'OR_IF' => 116,
			'AND_IF' => 117
		},
		DEFAULT => -35
	},
	{#State 69
		DEFAULT => -140
	},
	{#State 70
		ACTIONS => {
			"(" => 131,
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 130,
			'newline_list' => 2
		}
	},
	{#State 71
		DEFAULT => -116
	},
	{#State 72
		DEFAULT => -112
	},
	{#State 73
		DEFAULT => -114
	},
	{#State 74
		ACTIONS => {
			'NEWLINE' => 57
		},
		DEFAULT => -137
	},
	{#State 75
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 3,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 132,
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'newline_list' => 2,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 133,
			'while_clause' => 55
		}
	},
	{#State 76
		DEFAULT => -135
	},
	{#State 77
		DEFAULT => -134
	},
	{#State 78
		DEFAULT => -5
	},
	{#State 79
		DEFAULT => -118
	},
	{#State 80
		ACTIONS => {
			'Rbrace' => 134
		}
	},
	{#State 81
		ACTIONS => {
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 135,
			'newline_list' => 2
		}
	},
	{#State 82
		DEFAULT => -123
	},
	{#State 83
		DEFAULT => -129
	},
	{#State 84
		DEFAULT => -128
	},
	{#State 85
		DEFAULT => -120
	},
	{#State 86
		ACTIONS => {
			")" => 136
		}
	},
	{#State 87
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 137,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 88
		DEFAULT => -119
	},
	{#State 89
		ACTIONS => {
			'Do' => 124
		},
		GOTOS => {
			'do_group' => 138
		}
	},
	{#State 90
		ACTIONS => {
			";" => 128,
			'NEWLINE' => 3
		},
		GOTOS => {
			'newline_list' => 127,
			'sequential_sep' => 139
		}
	},
	{#State 91
		DEFAULT => -115
	},
	{#State 92
		DEFAULT => -109
	},
	{#State 93
		ACTIONS => {
			'ANDGREAT' => 31,
			"<" => 7,
			'LESSGREAT' => 36,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'LESSAND' => 20,
			'DLESS' => 47,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			'DGREAT' => 52,
			">" => 29
		},
		DEFAULT => -18,
		GOTOS => {
			'io_here' => 37,
			'io_file' => 32,
			'io_redirect' => 140
		}
	},
	{#State 94
		DEFAULT => -122
	},
	{#State 95
		DEFAULT => -100
	},
	{#State 96
		DEFAULT => -104
	},
	{#State 97
		DEFAULT => -102
	},
	{#State 98
		ACTIONS => {
			'WORD' => 108,
			'ANDGREAT' => 31,
			"<" => 7,
			'LESSGREAT' => 36,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'LESSAND' => 20,
			'DLESS' => 47,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			'DGREAT' => 52,
			">" => 29
		},
		DEFAULT => -95,
		GOTOS => {
			'io_here' => 37,
			'io_file' => 32,
			'io_redirect' => 109,
			'cmd_suffix' => 141
		}
	},
	{#State 99
		ACTIONS => {
			'Then' => 142
		}
	},
	{#State 100
		ACTIONS => {
			";" => 128,
			'NEWLINE' => 3
		},
		GOTOS => {
			'newline_list' => 127,
			'sequential_sep' => 143
		}
	},
	{#State 101
		ACTIONS => {
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 132,
			'newline_list' => 2
		}
	},
	{#State 102
		DEFAULT => -6
	},
	{#State 103
		DEFAULT => -3
	},
	{#State 104
		ACTIONS => {
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 144,
			'newline_list' => 2
		}
	},
	{#State 105
		DEFAULT => -45
	},
	{#State 106
		ACTIONS => {
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 145,
			'newline_list' => 2
		}
	},
	{#State 107
		DEFAULT => -127
	},
	{#State 108
		DEFAULT => -107
	},
	{#State 109
		DEFAULT => -105
	},
	{#State 110
		ACTIONS => {
			'WORD' => 146,
			'ANDGREAT' => 31,
			"<" => 7,
			'LESSGREAT' => 36,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'LESSAND' => 20,
			'DLESS' => 47,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			'DGREAT' => 52,
			">" => 29
		},
		DEFAULT => -97,
		GOTOS => {
			'io_here' => 37,
			'io_file' => 32,
			'io_redirect' => 147
		}
	},
	{#State 111
		ACTIONS => {
			"|" => 106
		},
		DEFAULT => -13
	},
	{#State 112
		DEFAULT => -121
	},
	{#State 113
		DEFAULT => -79
	},
	{#State 114
		DEFAULT => -78
	},
	{#State 115
		ACTIONS => {
			'WORD' => 149,
			"]]" => 150,
			'NEWLINE' => 3
		},
		GOTOS => {
			'linebreak' => 148,
			'newline_list' => 2
		}
	},
	{#State 116
		ACTIONS => {
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 151,
			'newline_list' => 2
		}
	},
	{#State 117
		ACTIONS => {
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 152,
			'newline_list' => 2
		}
	},
	{#State 118
		ACTIONS => {
			";" => 128,
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 153,
			'newline_list' => 154,
			'sequential_sep' => 155
		}
	},
	{#State 119
		ACTIONS => {
			'WORD' => 114,
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 113,
			'newline_list' => 2,
			'expression' => 156
		}
	},
	{#State 120
		ACTIONS => {
			";" => 76,
			"&" => 77,
			")" => 157,
			'NEWLINE' => 3
		},
		GOTOS => {
			'newline_list' => 74,
			'separator' => 158,
			'separator_op' => 101
		}
	},
	{#State 121
		ACTIONS => {
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 159,
			'newline_list' => 2
		}
	},
	{#State 122
		ACTIONS => {
			";" => 76,
			"&" => 77,
			'NEWLINE' => 3
		},
		DEFAULT => -31,
		GOTOS => {
			'newline_list' => 74,
			'separator' => 160,
			'separator_op' => 101
		}
	},
	{#State 123
		DEFAULT => -84
	},
	{#State 124
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 3,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'newline_list' => 63,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 65,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'compound_list' => 161,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 125
		ACTIONS => {
			'WORD' => 5,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			">" => 29,
			'While' => 30,
			'ANDGREAT' => 31,
			'LESSGREAT' => 36,
			'If' => 41,
			'Select' => 44,
			'DLESS' => 47,
			'Bang' => 50,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56
		},
		DEFAULT => -32,
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 162,
			'while_clause' => 55
		}
	},
	{#State 126
		ACTIONS => {
			'WORD' => 149,
			"))" => 163,
			'NEWLINE' => 3
		},
		GOTOS => {
			'linebreak' => 148,
			'newline_list' => 2
		}
	},
	{#State 127
		ACTIONS => {
			'NEWLINE' => 57
		},
		DEFAULT => -139
	},
	{#State 128
		ACTIONS => {
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 164,
			'newline_list' => 2
		}
	},
	{#State 129
		ACTIONS => {
			'Do' => 124
		},
		GOTOS => {
			'do_group' => 165
		}
	},
	{#State 130
		ACTIONS => {
			'Case' => 22,
			'Lbrace' => 21,
			'Until' => 12,
			"(" => 27,
			'If' => 41,
			'Select' => 44,
			'For' => 56,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'subshell' => 34,
			'compound_command' => 167,
			'select_clause' => 51,
			'for_clause' => 23,
			'brace_group' => 14,
			'if_clause' => 39,
			'until_clause' => 28,
			'while_clause' => 55,
			'function_body' => 166
		}
	},
	{#State 131
		ACTIONS => {
			")" => 168
		}
	},
	{#State 132
		DEFAULT => -136
	},
	{#State 133
		ACTIONS => {
			'OR_IF' => 116,
			'AND_IF' => 117
		},
		DEFAULT => -7
	},
	{#State 134
		DEFAULT => -92
	},
	{#State 135
		ACTIONS => {
			'In' => 170
		},
		GOTOS => {
			'in' => 169
		}
	},
	{#State 136
		DEFAULT => -29
	},
	{#State 137
		ACTIONS => {
			";" => 76,
			"&" => 77,
			")" => 171,
			'NEWLINE' => 3
		},
		GOTOS => {
			'newline_list' => 74,
			'separator' => 158,
			'separator_op' => 101
		}
	},
	{#State 138
		DEFAULT => -82
	},
	{#State 139
		ACTIONS => {
			'Do' => 124
		},
		GOTOS => {
			'do_group' => 172
		}
	},
	{#State 140
		DEFAULT => -110
	},
	{#State 141
		ACTIONS => {
			'WORD' => 146,
			'ANDGREAT' => 31,
			"<" => 7,
			'LESSGREAT' => 36,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'LESSAND' => 20,
			'DLESS' => 47,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			'DGREAT' => 52,
			">" => 29
		},
		DEFAULT => -94,
		GOTOS => {
			'io_here' => 37,
			'io_file' => 32,
			'io_redirect' => 147
		}
	},
	{#State 142
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 3,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'newline_list' => 63,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 65,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'compound_list' => 173,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 143
		ACTIONS => {
			'Then' => 174
		}
	},
	{#State 144
		ACTIONS => {
			'Do' => 124,
			'In' => 170
		},
		GOTOS => {
			'in' => 175,
			'do_group' => 176
		}
	},
	{#State 145
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'function_definition' => 17,
			'command' => 177,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'while_clause' => 55
		}
	},
	{#State 146
		DEFAULT => -108
	},
	{#State 147
		DEFAULT => -106
	},
	{#State 148
		DEFAULT => -81
	},
	{#State 149
		DEFAULT => -80
	},
	{#State 150
		DEFAULT => -76
	},
	{#State 151
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'function_definition' => 17,
			'pipeline' => 178,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'while_clause' => 55
		}
	},
	{#State 152
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'function_definition' => 17,
			'pipeline' => 179,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'while_clause' => 55
		}
	},
	{#State 153
		ACTIONS => {
			'Do' => 124,
			'In' => 170
		},
		GOTOS => {
			'in' => 180,
			'do_group' => 181
		}
	},
	{#State 154
		ACTIONS => {
			'NEWLINE' => 57
		},
		DEFAULT => -132
	},
	{#State 155
		ACTIONS => {
			'Do' => 124
		},
		GOTOS => {
			'do_group' => 182
		}
	},
	{#State 156
		ACTIONS => {
			'WORD' => 149,
			"))" => 183,
			'NEWLINE' => 3
		},
		GOTOS => {
			'linebreak' => 148,
			'newline_list' => 2
		}
	},
	{#State 157
		DEFAULT => -124
	},
	{#State 158
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 162,
			'while_clause' => 55
		}
	},
	{#State 159
		ACTIONS => {
			'Case' => 22,
			'Lbrace' => 21,
			'Until' => 12,
			"(" => 27,
			'If' => 41,
			'Select' => 44,
			'For' => 56,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'subshell' => 34,
			'compound_command' => 167,
			'select_clause' => 51,
			'for_clause' => 23,
			'brace_group' => 14,
			'if_clause' => 39,
			'until_clause' => 28,
			'while_clause' => 55,
			'function_body' => 184
		}
	},
	{#State 160
		ACTIONS => {
			'WORD' => 5,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			">" => 29,
			'While' => 30,
			'ANDGREAT' => 31,
			'LESSGREAT' => 36,
			'If' => 41,
			'Select' => 44,
			'DLESS' => 47,
			'Bang' => 50,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56
		},
		DEFAULT => -33,
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 162,
			'while_clause' => 55
		}
	},
	{#State 161
		ACTIONS => {
			'Done' => 185
		}
	},
	{#State 162
		ACTIONS => {
			'OR_IF' => 116,
			'AND_IF' => 117
		},
		DEFAULT => -34
	},
	{#State 163
		DEFAULT => -77
	},
	{#State 164
		DEFAULT => -138
	},
	{#State 165
		DEFAULT => -85
	},
	{#State 166
		DEFAULT => -87
	},
	{#State 167
		ACTIONS => {
			'ANDGREAT' => 31,
			"<" => 7,
			'LESSGREAT' => 36,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'LESSAND' => 20,
			'DLESS' => 47,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			'DGREAT' => 52,
			">" => 29
		},
		DEFAULT => -89,
		GOTOS => {
			'io_here' => 37,
			'io_file' => 32,
			'io_redirect' => 92,
			'redirect_list' => 186
		}
	},
	{#State 168
		ACTIONS => {
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 187,
			'newline_list' => 2
		}
	},
	{#State 169
		ACTIONS => {
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 188,
			'newline_list' => 2
		}
	},
	{#State 170
		DEFAULT => -46
	},
	{#State 171
		DEFAULT => -125
	},
	{#State 172
		DEFAULT => -83
	},
	{#State 173
		ACTIONS => {
			'Elif' => 189,
			'Else' => 192,
			'Fi' => 190
		},
		GOTOS => {
			'else_part' => 191
		}
	},
	{#State 174
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 3,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'newline_list' => 63,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 65,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'compound_list' => 193,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 175
		ACTIONS => {
			'WORD' => 194
		},
		GOTOS => {
			'wordlist' => 195
		}
	},
	{#State 176
		DEFAULT => -36
	},
	{#State 177
		DEFAULT => -15
	},
	{#State 178
		DEFAULT => -11
	},
	{#State 179
		DEFAULT => -10
	},
	{#State 180
		ACTIONS => {
			'WORD' => 194,
			";" => 128,
			'NEWLINE' => 3
		},
		GOTOS => {
			'newline_list' => 127,
			'wordlist' => 196,
			'sequential_sep' => 197
		}
	},
	{#State 181
		DEFAULT => -40
	},
	{#State 182
		DEFAULT => -41
	},
	{#State 183
		ACTIONS => {
			";" => 128,
			'NEWLINE' => 3
		},
		DEFAULT => -39,
		GOTOS => {
			'newline_list' => 127,
			'OPTIONAL-1' => 198,
			'sequential_sep' => 199
		}
	},
	{#State 184
		DEFAULT => -88
	},
	{#State 185
		DEFAULT => -93
	},
	{#State 186
		ACTIONS => {
			'ANDGREAT' => 31,
			"<" => 7,
			'LESSGREAT' => 36,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'LESSAND' => 20,
			'DLESS' => 47,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			'DGREAT' => 52,
			">" => 29
		},
		DEFAULT => -90,
		GOTOS => {
			'io_here' => 37,
			'io_file' => 32,
			'io_redirect' => 140
		}
	},
	{#State 187
		ACTIONS => {
			'Case' => 22,
			'Lbrace' => 21,
			'Until' => 12,
			"(" => 27,
			'If' => 41,
			'Select' => 44,
			'For' => 56,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'subshell' => 34,
			'compound_command' => 167,
			'select_clause' => 51,
			'for_clause' => 23,
			'brace_group' => 14,
			'if_clause' => 39,
			'until_clause' => 28,
			'while_clause' => 55,
			'function_body' => 200
		}
	},
	{#State 188
		ACTIONS => {
			'WORD' => 201,
			"(" => 205,
			'Esac' => 204
		},
		GOTOS => {
			'case_item' => 202,
			'pattern' => 209,
			'case_list_ns' => 203,
			'case_item_ns' => 208,
			'pattern_list' => 206,
			'case_list' => 207
		}
	},
	{#State 189
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 3,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'newline_list' => 63,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 65,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'compound_list' => 210,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 190
		DEFAULT => -70
	},
	{#State 191
		ACTIONS => {
			'Fi' => 211
		}
	},
	{#State 192
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 3,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'newline_list' => 63,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 65,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'compound_list' => 212,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 193
		ACTIONS => {
			'Elif' => 189,
			'Else' => 192,
			'Fi' => 213
		},
		GOTOS => {
			'else_part' => 214
		}
	},
	{#State 194
		DEFAULT => -48
	},
	{#State 195
		ACTIONS => {
			'WORD' => 215,
			";" => 128,
			'NEWLINE' => 3
		},
		GOTOS => {
			'newline_list' => 127,
			'sequential_sep' => 216
		}
	},
	{#State 196
		ACTIONS => {
			'WORD' => 215,
			";" => 128,
			'NEWLINE' => 3
		},
		GOTOS => {
			'newline_list' => 127,
			'sequential_sep' => 217
		}
	},
	{#State 197
		ACTIONS => {
			'Do' => 124
		},
		GOTOS => {
			'do_group' => 218
		}
	},
	{#State 198
		ACTIONS => {
			'Do' => 124
		},
		GOTOS => {
			'do_group' => 219
		}
	},
	{#State 199
		DEFAULT => -38
	},
	{#State 200
		DEFAULT => -86
	},
	{#State 201
		DEFAULT => -64
	},
	{#State 202
		DEFAULT => -55
	},
	{#State 203
		ACTIONS => {
			'Esac' => 220
		}
	},
	{#State 204
		DEFAULT => -51
	},
	{#State 205
		ACTIONS => {
			'WORD' => 201,
			"(" => 221
		},
		GOTOS => {
			'pattern' => 209,
			'pattern_list' => 222
		}
	},
	{#State 206
		ACTIONS => {
			")" => 223
		}
	},
	{#State 207
		ACTIONS => {
			'WORD' => 201,
			"(" => 205,
			'Esac' => 225
		},
		GOTOS => {
			'case_item' => 224,
			'pattern' => 209,
			'case_item_ns' => 226,
			'pattern_list' => 206
		}
	},
	{#State 208
		DEFAULT => -53
	},
	{#State 209
		ACTIONS => {
			'WORD' => 201,
			"|" => 227,
			"(" => 221
		},
		DEFAULT => -67,
		GOTOS => {
			'pattern' => 228
		}
	},
	{#State 210
		ACTIONS => {
			'Then' => 229
		}
	},
	{#State 211
		DEFAULT => -69
	},
	{#State 212
		DEFAULT => -75
	},
	{#State 213
		DEFAULT => -72
	},
	{#State 214
		ACTIONS => {
			'Fi' => 230
		}
	},
	{#State 215
		DEFAULT => -47
	},
	{#State 216
		ACTIONS => {
			'Do' => 124
		},
		GOTOS => {
			'do_group' => 231
		}
	},
	{#State 217
		ACTIONS => {
			'Do' => 124
		},
		GOTOS => {
			'do_group' => 232
		}
	},
	{#State 218
		DEFAULT => -42
	},
	{#State 219
		DEFAULT => -44
	},
	{#State 220
		DEFAULT => -50
	},
	{#State 221
		ACTIONS => {
			'WORD' => 201,
			"(" => 221
		},
		GOTOS => {
			'pattern' => 209,
			'pattern_list' => 233
		}
	},
	{#State 222
		ACTIONS => {
			")" => 234
		}
	},
	{#State 223
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 3,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 235,
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'newline_list' => 236,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 65,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'compound_list' => 237,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 224
		DEFAULT => -54
	},
	{#State 225
		DEFAULT => -49
	},
	{#State 226
		DEFAULT => -52
	},
	{#State 227
		ACTIONS => {
			'WORD' => 201,
			"(" => 221
		},
		GOTOS => {
			'pattern' => 238
		}
	},
	{#State 228
		ACTIONS => {
			'WORD' => 201,
			"(" => 221
		},
		DEFAULT => -66,
		GOTOS => {
			'pattern' => 228
		}
	},
	{#State 229
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 3,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'newline_list' => 63,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 65,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'compound_list' => 239,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 230
		DEFAULT => -71
	},
	{#State 231
		DEFAULT => -37
	},
	{#State 232
		DEFAULT => -43
	},
	{#State 233
		ACTIONS => {
			")" => 240
		}
	},
	{#State 234
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 3,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			'DSEMI' => -133,
			'Esac' => -133,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		DEFAULT => -65,
		GOTOS => {
			'linebreak' => 241,
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'newline_list' => 236,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 65,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'compound_list' => 242,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 235
		ACTIONS => {
			'DSEMI' => 243
		},
		DEFAULT => -56
	},
	{#State 236
		ACTIONS => {
			'WORD' => 5,
			'ANDGREAT' => 31,
			"<" => 7,
			'Until' => 12,
			'Function' => 13,
			'LESSGREAT' => 36,
			'If' => 41,
			'TLESS' => 15,
			'IO_NUMBER' => 16,
			'Select' => 44,
			'NEWLINE' => 57,
			'DLESS' => 47,
			'LESSAND' => 20,
			'Lbrace' => 21,
			'Case' => 22,
			'Bang' => 50,
			'CLOBBER' => 24,
			'DLESSDASH' => 25,
			'GREATAND' => 26,
			"(" => 27,
			'DGREAT' => 52,
			"[[" => 53,
			'For' => 56,
			">" => 29,
			'While' => 30
		},
		DEFAULT => -132,
		GOTOS => {
			'case_clause' => 6,
			'compound_command' => 33,
			'subshell' => 34,
			'io_file' => 32,
			'dbracket' => 10,
			'io_redirect' => 9,
			'ASSIGNMENT_WORD' => 8,
			'fname' => 11,
			'term' => 122,
			'simple_command' => 38,
			'io_here' => 37,
			'if_clause' => 39,
			'brace_group' => 14,
			'cmd_prefix' => 40,
			'function_definition' => 17,
			'pipeline' => 18,
			'pipe_sequence' => 46,
			'command' => 45,
			'NAME' => 49,
			'cmd_name' => 48,
			'select_clause' => 51,
			'for_clause' => 23,
			'until_clause' => 28,
			'and_or' => 68,
			'while_clause' => 55
		}
	},
	{#State 237
		ACTIONS => {
			'DSEMI' => 245,
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 244,
			'newline_list' => 2
		}
	},
	{#State 238
		ACTIONS => {
			'WORD' => 201,
			"(" => 221
		},
		DEFAULT => -68,
		GOTOS => {
			'pattern' => 228
		}
	},
	{#State 239
		ACTIONS => {
			'Elif' => 189,
			'Else' => 192
		},
		DEFAULT => -73,
		GOTOS => {
			'else_part' => 246
		}
	},
	{#State 240
		DEFAULT => -65
	},
	{#State 241
		ACTIONS => {
			'DSEMI' => 247
		},
		DEFAULT => -58
	},
	{#State 242
		ACTIONS => {
			'DSEMI' => 249,
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 248,
			'newline_list' => 2
		}
	},
	{#State 243
		ACTIONS => {
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 250,
			'newline_list' => 2
		}
	},
	{#State 244
		DEFAULT => -57
	},
	{#State 245
		ACTIONS => {
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 251,
			'newline_list' => 2
		}
	},
	{#State 246
		DEFAULT => -74
	},
	{#State 247
		ACTIONS => {
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 252,
			'newline_list' => 2
		}
	},
	{#State 248
		DEFAULT => -59
	},
	{#State 249
		ACTIONS => {
			'NEWLINE' => 3
		},
		DEFAULT => -133,
		GOTOS => {
			'linebreak' => 253,
			'newline_list' => 2
		}
	},
	{#State 250
		DEFAULT => -60
	},
	{#State 251
		DEFAULT => -61
	},
	{#State 252
		DEFAULT => -62
	},
	{#State 253
		DEFAULT => -63
	}
],
                                  yyrules  =>
[
	[#Rule _SUPERSTART
		 '$start', 2, undef
#line 5427 ShParser.pm
	],
	[#Rule start_1
		 'start', 2,
sub {
#line 30 "src/sh.yp"
 goto &Parse::Eyapp::Driver::YYBuildAST }
#line 5434 ShParser.pm
	],
	[#Rule start_1_2
		 'start_1', 1,
sub {
#line 30 "src/sh.yp"
 goto &Parse::Eyapp::Driver::YYBuildAST }
#line 5441 ShParser.pm
	],
	[#Rule start_1_3
		 'start_1', 2,
sub {
#line 30 "src/sh.yp"
 goto &Parse::Eyapp::Driver::YYBuildAST }
#line 5448 ShParser.pm
	],
	[#Rule start_1_4
		 'start_1', 0,
sub {
#line 30 "src/sh.yp"
 goto &Parse::Eyapp::Driver::YYBuildAST }
#line 5455 ShParser.pm
	],
	[#Rule complete_command_5
		 'complete_command', 2,
sub {
#line 30 "src/sh.yp"
 goto &Parse::Eyapp::Driver::YYBuildAST }
#line 5462 ShParser.pm
	],
	[#Rule complete_command_6
		 'complete_command', 2,
sub {
#line 138 "src/sh.yp"
 $_[0]->YYErrok; undef; }
#line 5469 ShParser.pm
	],
	[#Rule list_7
		 'list', 3,
sub {
#line 140 "src/sh.yp"
 undef; }
#line 5476 ShParser.pm
	],
	[#Rule list_8
		 'list', 1,
sub {
#line 141 "src/sh.yp"
 undef; }
#line 5483 ShParser.pm
	],
	[#Rule and_or_9
		 'and_or', 1,
sub {
#line 143 "src/sh.yp"
 undef; }
#line 5490 ShParser.pm
	],
	[#Rule and_or_10
		 'and_or', 4,
sub {
#line 144 "src/sh.yp"
 undef; }
#line 5497 ShParser.pm
	],
	[#Rule and_or_11
		 'and_or', 4,
sub {
#line 145 "src/sh.yp"
 undef; }
#line 5504 ShParser.pm
	],
	[#Rule pipeline_12
		 'pipeline', 1,
sub {
#line 147 "src/sh.yp"
 undef; }
#line 5511 ShParser.pm
	],
	[#Rule pipeline_13
		 'pipeline', 2,
sub {
#line 148 "src/sh.yp"
 undef; }
#line 5518 ShParser.pm
	],
	[#Rule pipe_sequence_14
		 'pipe_sequence', 1,
sub {
#line 150 "src/sh.yp"
 undef; }
#line 5525 ShParser.pm
	],
	[#Rule pipe_sequence_15
		 'pipe_sequence', 4,
sub {
#line 151 "src/sh.yp"
 undef; }
#line 5532 ShParser.pm
	],
	[#Rule command_16
		 'command', 1,
sub {
#line 153 "src/sh.yp"
 undef; }
#line 5539 ShParser.pm
	],
	[#Rule command_17
		 'command', 1,
sub {
#line 154 "src/sh.yp"
 undef; }
#line 5546 ShParser.pm
	],
	[#Rule command_18
		 'command', 2,
sub {
#line 155 "src/sh.yp"
 undef; }
#line 5553 ShParser.pm
	],
	[#Rule command_19
		 'command', 1,
sub {
#line 156 "src/sh.yp"
 undef; }
#line 5560 ShParser.pm
	],
	[#Rule command_20
		 'command', 1,
sub {
#line 157 "src/sh.yp"
 undef; }
#line 5567 ShParser.pm
	],
	[#Rule compound_command_21
		 'compound_command', 1,
sub {
#line 159 "src/sh.yp"
 undef; }
#line 5574 ShParser.pm
	],
	[#Rule compound_command_22
		 'compound_command', 1,
sub {
#line 160 "src/sh.yp"
 undef; }
#line 5581 ShParser.pm
	],
	[#Rule compound_command_23
		 'compound_command', 1,
sub {
#line 161 "src/sh.yp"
 undef; }
#line 5588 ShParser.pm
	],
	[#Rule compound_command_24
		 'compound_command', 1,
sub {
#line 162 "src/sh.yp"
 undef; }
#line 5595 ShParser.pm
	],
	[#Rule compound_command_25
		 'compound_command', 1,
sub {
#line 163 "src/sh.yp"
 undef; }
#line 5602 ShParser.pm
	],
	[#Rule compound_command_26
		 'compound_command', 1,
sub {
#line 164 "src/sh.yp"
 undef; }
#line 5609 ShParser.pm
	],
	[#Rule compound_command_27
		 'compound_command', 1,
sub {
#line 165 "src/sh.yp"
 undef; }
#line 5616 ShParser.pm
	],
	[#Rule compound_command_28
		 'compound_command', 1,
sub {
#line 166 "src/sh.yp"
 undef; }
#line 5623 ShParser.pm
	],
	[#Rule subshell_29
		 'subshell', 3,
sub {
#line 168 "src/sh.yp"
 undef; }
#line 5630 ShParser.pm
	],
	[#Rule compound_list_30
		 'compound_list', 1,
sub {
#line 170 "src/sh.yp"
 undef; }
#line 5637 ShParser.pm
	],
	[#Rule compound_list_31
		 'compound_list', 2,
sub {
#line 171 "src/sh.yp"
 undef; }
#line 5644 ShParser.pm
	],
	[#Rule compound_list_32
		 'compound_list', 2,
sub {
#line 172 "src/sh.yp"
 undef; }
#line 5651 ShParser.pm
	],
	[#Rule compound_list_33
		 'compound_list', 3,
sub {
#line 173 "src/sh.yp"
 undef; }
#line 5658 ShParser.pm
	],
	[#Rule term_34
		 'term', 3,
sub {
#line 175 "src/sh.yp"
 undef; }
#line 5665 ShParser.pm
	],
	[#Rule term_35
		 'term', 1,
sub {
#line 176 "src/sh.yp"
 undef; }
#line 5672 ShParser.pm
	],
	[#Rule select_clause_36
		 'select_clause', 4,
sub {
#line 178 "src/sh.yp"
 Hooked($_[0], 'SELECT', $_[1]); undef; }
#line 5679 ShParser.pm
	],
	[#Rule select_clause_37
		 'select_clause', 7,
sub {
#line 179 "src/sh.yp"
 Hooked($_[0], 'SELECT', $_[1]); undef; }
#line 5686 ShParser.pm
	],
	[#Rule _OPTIONAL
		 'OPTIONAL-1', 1,
sub {
#line 185 "src/sh.yp"
 goto &Parse::Eyapp::Driver::YYActionforT_single }
#line 5693 ShParser.pm
	],
	[#Rule _OPTIONAL
		 'OPTIONAL-1', 0,
sub {
#line 185 "src/sh.yp"
 goto &Parse::Eyapp::Driver::YYActionforT_empty }
#line 5700 ShParser.pm
	],
	[#Rule for_clause_40
		 'for_clause', 4,
sub {
#line 181 "src/sh.yp"
 undef; }
#line 5707 ShParser.pm
	],
	[#Rule for_clause_41
		 'for_clause', 4,
sub {
#line 182 "src/sh.yp"
 Hooked($_[0], 'FOR_VARSEMI', $_[2]); undef; }
#line 5714 ShParser.pm
	],
	[#Rule for_clause_42
		 'for_clause', 6,
sub {
#line 183 "src/sh.yp"
 undef; }
#line 5721 ShParser.pm
	],
	[#Rule for_clause_43
		 'for_clause', 7,
sub {
#line 184 "src/sh.yp"
 undef; }
#line 5728 ShParser.pm
	],
	[#Rule for_clause_44
		 'for_clause', 6,
sub {
#line 185 "src/sh.yp"
 Hooked($_[0], 'LOOP_DPAR', $_[1]); undef; }
#line 5735 ShParser.pm
	],
	[#Rule name_45
		 'name', 1,
sub {
#line 187 "src/sh.yp"
 return $_[1]; }
#line 5742 ShParser.pm
	],
	[#Rule in_46
		 'in', 1,
sub {
#line 189 "src/sh.yp"
 return $_[1]; }
#line 5749 ShParser.pm
	],
	[#Rule wordlist_47
		 'wordlist', 2,
sub {
#line 191 "src/sh.yp"
 undef; }
#line 5756 ShParser.pm
	],
	[#Rule wordlist_48
		 'wordlist', 1,
sub {
#line 192 "src/sh.yp"
 undef; }
#line 5763 ShParser.pm
	],
	[#Rule case_clause_49
		 'case_clause', 7,
sub {
#line 194 "src/sh.yp"
 undef; }
#line 5770 ShParser.pm
	],
	[#Rule case_clause_50
		 'case_clause', 7,
sub {
#line 195 "src/sh.yp"
 undef; }
#line 5777 ShParser.pm
	],
	[#Rule case_clause_51
		 'case_clause', 6,
sub {
#line 196 "src/sh.yp"
 undef; }
#line 5784 ShParser.pm
	],
	[#Rule case_list_ns_52
		 'case_list_ns', 2,
sub {
#line 198 "src/sh.yp"
 undef; }
#line 5791 ShParser.pm
	],
	[#Rule case_list_ns_53
		 'case_list_ns', 1,
sub {
#line 199 "src/sh.yp"
 undef; }
#line 5798 ShParser.pm
	],
	[#Rule case_list_54
		 'case_list', 2,
sub {
#line 201 "src/sh.yp"
 undef; }
#line 5805 ShParser.pm
	],
	[#Rule case_list_55
		 'case_list', 1,
sub {
#line 202 "src/sh.yp"
 undef; }
#line 5812 ShParser.pm
	],
	[#Rule case_item_ns_56
		 'case_item_ns', 3,
sub {
#line 204 "src/sh.yp"
 undef; }
#line 5819 ShParser.pm
	],
	[#Rule case_item_ns_57
		 'case_item_ns', 4,
sub {
#line 205 "src/sh.yp"
 undef; }
#line 5826 ShParser.pm
	],
	[#Rule case_item_ns_58
		 'case_item_ns', 4,
sub {
#line 206 "src/sh.yp"
 undef; }
#line 5833 ShParser.pm
	],
	[#Rule case_item_ns_59
		 'case_item_ns', 5,
sub {
#line 207 "src/sh.yp"
 undef; }
#line 5840 ShParser.pm
	],
	[#Rule case_item_60
		 'case_item', 5,
sub {
#line 209 "src/sh.yp"
 undef; }
#line 5847 ShParser.pm
	],
	[#Rule case_item_61
		 'case_item', 5,
sub {
#line 210 "src/sh.yp"
 undef; }
#line 5854 ShParser.pm
	],
	[#Rule case_item_62
		 'case_item', 6,
sub {
#line 211 "src/sh.yp"
 undef; }
#line 5861 ShParser.pm
	],
	[#Rule case_item_63
		 'case_item', 6,
sub {
#line 212 "src/sh.yp"
 undef; }
#line 5868 ShParser.pm
	],
	[#Rule pattern_64
		 'pattern', 1,
sub {
#line 214 "src/sh.yp"
 undef; }
#line 5875 ShParser.pm
	],
	[#Rule pattern_65
		 'pattern', 3,
sub {
#line 215 "src/sh.yp"
 undef; }
#line 5882 ShParser.pm
	],
	[#Rule pattern_66
		 'pattern', 2,
sub {
#line 216 "src/sh.yp"
 undef; }
#line 5889 ShParser.pm
	],
	[#Rule pattern_list_67
		 'pattern_list', 1,
sub {
#line 218 "src/sh.yp"
 undef; }
#line 5896 ShParser.pm
	],
	[#Rule pattern_list_68
		 'pattern_list', 3,
sub {
#line 219 "src/sh.yp"
 undef; }
#line 5903 ShParser.pm
	],
	[#Rule if_clause_69
		 'if_clause', 6,
sub {
#line 221 "src/sh.yp"
 undef; }
#line 5910 ShParser.pm
	],
	[#Rule if_clause_70
		 'if_clause', 5,
sub {
#line 222 "src/sh.yp"
 undef; }
#line 5917 ShParser.pm
	],
	[#Rule if_clause_71
		 'if_clause', 7,
sub {
#line 223 "src/sh.yp"
 undef; }
#line 5924 ShParser.pm
	],
	[#Rule if_clause_72
		 'if_clause', 6,
sub {
#line 224 "src/sh.yp"
 undef; }
#line 5931 ShParser.pm
	],
	[#Rule else_part_73
		 'else_part', 4,
sub {
#line 226 "src/sh.yp"
 undef; }
#line 5938 ShParser.pm
	],
	[#Rule else_part_74
		 'else_part', 5,
sub {
#line 227 "src/sh.yp"
 undef; }
#line 5945 ShParser.pm
	],
	[#Rule else_part_75
		 'else_part', 2,
sub {
#line 228 "src/sh.yp"
 undef; }
#line 5952 ShParser.pm
	],
	[#Rule dbracket_76
		 'dbracket', 3,
sub {
#line 230 "src/sh.yp"
 Hooked($_[0], 'DBRACKET', $_[1], @_); undef; }
#line 5959 ShParser.pm
	],
	[#Rule dparenthesis_77
		 'dparenthesis', 3,
sub {
#line 232 "src/sh.yp"
 Hooked($_[0], 'DPAR', $_[1]); undef; }
#line 5966 ShParser.pm
	],
	[#Rule expression_78
		 'expression', 1,
sub {
#line 30 "src/sh.yp"
 goto &Parse::Eyapp::Driver::YYBuildAST }
#line 5973 ShParser.pm
	],
	[#Rule expression_79
		 'expression', 1,
sub {
#line 30 "src/sh.yp"
 goto &Parse::Eyapp::Driver::YYBuildAST }
#line 5980 ShParser.pm
	],
	[#Rule expression_80
		 'expression', 2,
sub {
#line 30 "src/sh.yp"
 goto &Parse::Eyapp::Driver::YYBuildAST }
#line 5987 ShParser.pm
	],
	[#Rule expression_81
		 'expression', 2,
sub {
#line 30 "src/sh.yp"
 goto &Parse::Eyapp::Driver::YYBuildAST }
#line 5994 ShParser.pm
	],
	[#Rule while_clause_82
		 'while_clause', 3,
sub {
#line 239 "src/sh.yp"
 undef; }
#line 6001 ShParser.pm
	],
	[#Rule while_clause_83
		 'while_clause', 4,
sub {
#line 240 "src/sh.yp"
 undef; }
#line 6008 ShParser.pm
	],
	[#Rule until_clause_84
		 'until_clause', 3,
sub {
#line 242 "src/sh.yp"
 undef; }
#line 6015 ShParser.pm
	],
	[#Rule until_clause_85
		 'until_clause', 4,
sub {
#line 243 "src/sh.yp"
 undef; }
#line 6022 ShParser.pm
	],
	[#Rule function_definition_86
		 'function_definition', 6,
sub {
#line 245 "src/sh.yp"
 Hooked($_[0], 'BAD_FUNC_DEF', $_[2], @_); Hooked($_[0], 'FUNCTION', $_[2], @_); undef }
#line 6029 ShParser.pm
	],
	[#Rule function_definition_87
		 'function_definition', 4,
sub {
#line 246 "src/sh.yp"
 Hooked($_[0], 'BAD_FUNC_DEF', $_[2], @_); Hooked($_[0], 'FUNCTION', $_[2], @_); undef }
#line 6036 ShParser.pm
	],
	[#Rule function_definition_88
		 'function_definition', 5,
sub {
#line 247 "src/sh.yp"
 Hooked($_[0], 'FUNCTION', $_[1], @_); undef }
#line 6043 ShParser.pm
	],
	[#Rule function_body_89
		 'function_body', 1,
sub {
#line 249 "src/sh.yp"
 undef; }
#line 6050 ShParser.pm
	],
	[#Rule function_body_90
		 'function_body', 2,
sub {
#line 250 "src/sh.yp"
 undef; }
#line 6057 ShParser.pm
	],
	[#Rule fname_91
		 'fname', 1,
sub {
#line 252 "src/sh.yp"
 return $_[1]; }
#line 6064 ShParser.pm
	],
	[#Rule brace_group_92
		 'brace_group', 3,
sub {
#line 254 "src/sh.yp"
 undef; }
#line 6071 ShParser.pm
	],
	[#Rule do_group_93
		 'do_group', 3,
sub {
#line 256 "src/sh.yp"
 undef; }
#line 6078 ShParser.pm
	],
	[#Rule simple_command_94
		 'simple_command', 3,
sub {
#line 258 "src/sh.yp"
 OnCommand($_[0], $_[2], $_[3]); undef }
#line 6085 ShParser.pm
	],
	[#Rule simple_command_95
		 'simple_command', 2,
sub {
#line 259 "src/sh.yp"
 OnCommand($_[0], $_[2]); undef }
#line 6092 ShParser.pm
	],
	[#Rule simple_command_96
		 'simple_command', 1,
sub {
#line 30 "src/sh.yp"
 goto &Parse::Eyapp::Driver::YYBuildAST }
#line 6099 ShParser.pm
	],
	[#Rule simple_command_97
		 'simple_command', 2,
sub {
#line 261 "src/sh.yp"
 OnCommand($_[0], $_[1], $_[2]); undef }
#line 6106 ShParser.pm
	],
	[#Rule simple_command_98
		 'simple_command', 1,
sub {
#line 262 "src/sh.yp"
 OnCommand($_[0], $_[1]); undef }
#line 6113 ShParser.pm
	],
	[#Rule cmd_name_99
		 'cmd_name', 1,
sub {
#line 264 "src/sh.yp"
 return $_[1]; }
#line 6120 ShParser.pm
	],
	[#Rule cmd_word_100
		 'cmd_word', 1,
sub {
#line 266 "src/sh.yp"
 return $_[1]; }
#line 6127 ShParser.pm
	],
	[#Rule cmd_prefix_101
		 'cmd_prefix', 1,
sub {
#line 268 "src/sh.yp"
 undef; }
#line 6134 ShParser.pm
	],
	[#Rule cmd_prefix_102
		 'cmd_prefix', 2,
sub {
#line 269 "src/sh.yp"
 undef; }
#line 6141 ShParser.pm
	],
	[#Rule cmd_prefix_103
		 'cmd_prefix', 1,
sub {
#line 270 "src/sh.yp"
 undef; }
#line 6148 ShParser.pm
	],
	[#Rule cmd_prefix_104
		 'cmd_prefix', 2,
sub {
#line 271 "src/sh.yp"
 undef; }
#line 6155 ShParser.pm
	],
	[#Rule cmd_suffix_105
		 'cmd_suffix', 1,
sub {
#line 273 "src/sh.yp"
 my $f=AST(@_); $f->{linear}=[]; return $f; }
#line 6162 ShParser.pm
	],
	[#Rule cmd_suffix_106
		 'cmd_suffix', 2,
sub {
#line 274 "src/sh.yp"
 my $f=AST(@_); $f->{linear}=$_[1]->{linear}; return  $f; }
#line 6169 ShParser.pm
	],
	[#Rule cmd_suffix_107
		 'cmd_suffix', 1,
sub {
#line 275 "src/sh.yp"
 my $f=AST(@_); $f->{linear}=[$_[1]->[2]]; return $f; }
#line 6176 ShParser.pm
	],
	[#Rule cmd_suffix_108
		 'cmd_suffix', 2,
sub {
#line 276 "src/sh.yp"
 my $f=AST(@_); $f->{linear}=[@{$_[1]->{linear}}, $_[2]->[2]]; return $f; }
#line 6183 ShParser.pm
	],
	[#Rule redirect_list_109
		 'redirect_list', 1,
sub {
#line 278 "src/sh.yp"
 undef; }
#line 6190 ShParser.pm
	],
	[#Rule redirect_list_110
		 'redirect_list', 2,
sub {
#line 279 "src/sh.yp"
 undef; }
#line 6197 ShParser.pm
	],
	[#Rule io_redirect_111
		 'io_redirect', 1,
sub {
#line 281 "src/sh.yp"
 undef; }
#line 6204 ShParser.pm
	],
	[#Rule io_redirect_112
		 'io_redirect', 2,
sub {
#line 282 "src/sh.yp"
 undef; }
#line 6211 ShParser.pm
	],
	[#Rule io_redirect_113
		 'io_redirect', 1,
sub {
#line 283 "src/sh.yp"
 undef; }
#line 6218 ShParser.pm
	],
	[#Rule io_redirect_114
		 'io_redirect', 2,
sub {
#line 284 "src/sh.yp"
 undef; }
#line 6225 ShParser.pm
	],
	[#Rule io_redirect_115
		 'io_redirect', 2,
sub {
#line 285 "src/sh.yp"
 Hooked($_[0], 'ANDGREAT', $_[1]); undef }
#line 6232 ShParser.pm
	],
	[#Rule io_redirect_116
		 'io_redirect', 2,
sub {
#line 286 "src/sh.yp"
 Hooked($_[0], 'HERESTRING', $_[1]); undef }
#line 6239 ShParser.pm
	],
	[#Rule io_file_117
		 'io_file', 2,
sub {
#line 288 "src/sh.yp"
 undef; }
#line 6246 ShParser.pm
	],
	[#Rule io_file_118
		 'io_file', 2,
sub {
#line 289 "src/sh.yp"
 undef; }
#line 6253 ShParser.pm
	],
	[#Rule io_file_119
		 'io_file', 2,
sub {
#line 290 "src/sh.yp"
 undef; }
#line 6260 ShParser.pm
	],
	[#Rule io_file_120
		 'io_file', 2,
sub {
#line 291 "src/sh.yp"
 undef; }
#line 6267 ShParser.pm
	],
	[#Rule io_file_121
		 'io_file', 2,
sub {
#line 292 "src/sh.yp"
 undef; }
#line 6274 ShParser.pm
	],
	[#Rule io_file_122
		 'io_file', 2,
sub {
#line 293 "src/sh.yp"
 undef; }
#line 6281 ShParser.pm
	],
	[#Rule io_file_123
		 'io_file', 2,
sub {
#line 294 "src/sh.yp"
 undef; }
#line 6288 ShParser.pm
	],
	[#Rule io_file_124
		 'io_file', 4,
sub {
#line 295 "src/sh.yp"
 Hooked($_[0], 'PROCSUBST', $_[1]); undef }
#line 6295 ShParser.pm
	],
	[#Rule io_file_125
		 'io_file', 4,
sub {
#line 296 "src/sh.yp"
 Hooked($_[0], 'PROCSUBST', $_[1]); undef }
#line 6302 ShParser.pm
	],
	[#Rule filename_126
		 'filename', 1,
sub {
#line 298 "src/sh.yp"
 return $_[1]; }
#line 6309 ShParser.pm
	],
	[#Rule io_here_127
		 'io_here', 2,
sub {
#line 300 "src/sh.yp"
 undef; }
#line 6316 ShParser.pm
	],
	[#Rule io_here_128
		 'io_here', 2,
sub {
#line 301 "src/sh.yp"
 undef; }
#line 6323 ShParser.pm
	],
	[#Rule here_end_129
		 'here_end', 1,
sub {
#line 303 "src/sh.yp"
 return $_[1]; }
#line 6330 ShParser.pm
	],
	[#Rule newline_list_130
		 'newline_list', 1,
sub {
#line 305 "src/sh.yp"
 undef; }
#line 6337 ShParser.pm
	],
	[#Rule newline_list_131
		 'newline_list', 2,
sub {
#line 306 "src/sh.yp"
 undef; }
#line 6344 ShParser.pm
	],
	[#Rule linebreak_132
		 'linebreak', 1,
sub {
#line 308 "src/sh.yp"
 undef; }
#line 6351 ShParser.pm
	],
	[#Rule linebreak_133
		 'linebreak', 0,
sub {
#line 309 "src/sh.yp"
 undef; }
#line 6358 ShParser.pm
	],
	[#Rule separator_op_134
		 'separator_op', 1,
sub {
#line 30 "src/sh.yp"
 goto &Parse::Eyapp::Driver::YYBuildAST }
#line 6365 ShParser.pm
	],
	[#Rule separator_op_135
		 'separator_op', 1,
sub {
#line 30 "src/sh.yp"
 goto &Parse::Eyapp::Driver::YYBuildAST }
#line 6372 ShParser.pm
	],
	[#Rule separator_136
		 'separator', 2,
sub {
#line 314 "src/sh.yp"
 undef; }
#line 6379 ShParser.pm
	],
	[#Rule separator_137
		 'separator', 1,
sub {
#line 315 "src/sh.yp"
 undef; }
#line 6386 ShParser.pm
	],
	[#Rule sequential_sep_138
		 'sequential_sep', 2,
sub {
#line 317 "src/sh.yp"
 undef; }
#line 6393 ShParser.pm
	],
	[#Rule sequential_sep_139
		 'sequential_sep', 1,
sub {
#line 318 "src/sh.yp"
 undef; }
#line 6400 ShParser.pm
	],
	[#Rule NAME_140
		 'NAME', 1,
sub {
#line 320 "src/sh.yp"

        my $token = $_[1];
        if ( !is_name($token->[0]) ) {
            $_[0]->call_hook($token->[1], 'BADNAME', $token->[0]);
        }
        return $token;
    }
#line 6413 ShParser.pm
	],
	[#Rule ASSIGNMENT_WORD_141
		 'ASSIGNMENT_WORD', 1,
sub {
#line 328 "src/sh.yp"

        my $token = $_[1];
        if ( !is_assignment($token->[0]) ) {
            $_[0]->call_hook($token->[1], 'BAD_ASSIGNMENT', $token->[0]);
        }
        return $token;
    }
#line 6426 ShParser.pm
	]
],
#line 6429 ShParser.pm
                                  yybypass => 0,
                                  yybuildingtree => 1,
                                  @_,);
    bless($self,$class);

    $self->make_node_classes( qw{TERMINAL _OPTIONAL _STAR_LIST _PLUS_LIST 
         _SUPERSTART
         start_1
         start_1_2
         start_1_3
         start_1_4
         complete_command_5
         complete_command_6
         list_7
         list_8
         and_or_9
         and_or_10
         and_or_11
         pipeline_12
         pipeline_13
         pipe_sequence_14
         pipe_sequence_15
         command_16
         command_17
         command_18
         command_19
         command_20
         compound_command_21
         compound_command_22
         compound_command_23
         compound_command_24
         compound_command_25
         compound_command_26
         compound_command_27
         compound_command_28
         subshell_29
         compound_list_30
         compound_list_31
         compound_list_32
         compound_list_33
         term_34
         term_35
         select_clause_36
         select_clause_37
         for_clause_40
         for_clause_41
         for_clause_42
         for_clause_43
         for_clause_44
         name_45
         in_46
         wordlist_47
         wordlist_48
         case_clause_49
         case_clause_50
         case_clause_51
         case_list_ns_52
         case_list_ns_53
         case_list_54
         case_list_55
         case_item_ns_56
         case_item_ns_57
         case_item_ns_58
         case_item_ns_59
         case_item_60
         case_item_61
         case_item_62
         case_item_63
         pattern_64
         pattern_65
         pattern_66
         pattern_list_67
         pattern_list_68
         if_clause_69
         if_clause_70
         if_clause_71
         if_clause_72
         else_part_73
         else_part_74
         else_part_75
         dbracket_76
         dparenthesis_77
         expression_78
         expression_79
         expression_80
         expression_81
         while_clause_82
         while_clause_83
         until_clause_84
         until_clause_85
         function_definition_86
         function_definition_87
         function_definition_88
         function_body_89
         function_body_90
         fname_91
         brace_group_92
         do_group_93
         simple_command_94
         simple_command_95
         simple_command_96
         simple_command_97
         simple_command_98
         cmd_name_99
         cmd_word_100
         cmd_prefix_101
         cmd_prefix_102
         cmd_prefix_103
         cmd_prefix_104
         cmd_suffix_105
         cmd_suffix_106
         cmd_suffix_107
         cmd_suffix_108
         redirect_list_109
         redirect_list_110
         io_redirect_111
         io_redirect_112
         io_redirect_113
         io_redirect_114
         io_redirect_115
         io_redirect_116
         io_file_117
         io_file_118
         io_file_119
         io_file_120
         io_file_121
         io_file_122
         io_file_123
         io_file_124
         io_file_125
         filename_126
         io_here_127
         io_here_128
         here_end_129
         newline_list_130
         newline_list_131
         linebreak_132
         linebreak_133
         separator_op_134
         separator_op_135
         separator_136
         separator_137
         sequential_sep_138
         sequential_sep_139
         NAME_140
         ASSIGNMENT_WORD_141} );
    $self;
}

#line 337 "src/sh.yp"

# Tail section

sub AST {
    my $parser = shift;
    return $parser->YYBuildAST(@_);
}

sub call_hook {
    my $self = shift;
    my $linenum = shift;
    my $hook_name = shift;
    
    my $hook_func = $self->YYData->{HOOKS}{$hook_name};
    if ( !defined $hook_func ) {
        #die "Unknown hook: $hook_name"; # DBG:
        return undef;
    }

    if ( defined $self->YYData->{LINESHIFT} ) {
        $linenum += $self->YYData->{LINESHIFT}; # For parsing of subscripts
    }
    
    $self->YYData->{HOOK_INFO}{FILENAME} = $self->YYData->{FILENAME};
    $self->YYData->{HOOK_INFO}{LINENO} = $linenum;
    
    return &$hook_func($self, $hook_name, @_);
}

sub OnCommand {
    my $parser = shift;
    
    my ($cmdname, $linenum) = @{ $_[0] };
    my @params = ();
    if ( defined $_[1] ) {
        if ( defined $_[1]->{'linear'} ) {
            @params = @{$_[1]->{'linear'}};
        }
    }
    
    $parser->call_hook($linenum, 'COMMAND', $_[0], @params);
    
    return $parser->YYBuildAST(@_);
}

sub Hooked {
    my $parser = shift;
    my $hook = shift;
    my $tok = shift;
    
    my ($word, $linenum) = @$tok;
    
    $parser->call_hook($linenum, $hook, $word);
    
    return $parser->YYBuildAST(@_);
}

#-----------------------------------------------------------------------

sub limit_len {
    my ($line) = @_;
    
    if ( length($line) > 120 ) {
        return substr($line, 0,100);
    }
    
    $line =~ s/\s*\n$//s;
    
    return $line;
}

sub serialize {
    my ($arr) = @_;
    
    my $res = "";
    
    foreach my $elem ( @$arr ) {
        my $ref = ref $elem;
        
        if ( $ref eq "" ) {
            $res .= $elem;
        }
        elsif ( $ref eq "ARRAY" ) {
            $res .= serialize($elem);
        }
    }
    return $res;
}

sub unquote {
    my ($arr) = @_;
    
    my $res = "";
    
    foreach my $elem ( @$arr ) {
        my $ref = ref $elem;
        
        if ( $ref eq "" ) {
            $res .= $elem;
        }
        elsif ( $ref eq "ARRAY" ) {
            # make a copy
            my $copy = [@$elem];
            
            # remove quotes
            my $q = shift @$copy;
            pop @$copy;
            
            if ( $q eq "" || $q eq "'" || $q eq '"' ) {
                my $unquoted = unquote($copy);
                if ( not defined $unquoted ) {
                    return undef;
                }
                
                $res .= $unquoted;
            }
            elsif ( $q eq '\\' ) {
                $res .= $copy->[0];
            }
            else {
                return undef;
            }
        }
    }
    
    return $res;
}

## The shell shall read its input in terms of lines from a file,
## from a terminal in the case of an interactive shell, or from
## a string in the case of sh -c or system().
## The input lines can be of unlimited length.
## These lines shall be parsed using two major modes:
## ordinary token recognition and processing of here-documents.

sub read_line_sub {
    my ($self) = @_;
    
    my $s = "";
    if ( $self->YYData->{INPUT} =~ s/\G.*(\n|\z)// ) {
        $s = $&;
    }
    return undef if $s eq "";
    
    $self->YYData->{LINENO}++;
    
    return $s;
}

sub read_line {
    my ($self) = @_;
    
    # Read a new line
    my $line = $self->read_line_sub();

    $self->YYData->{LAST_LINE} = $line;
    
    return $line;
}

my $expect_heredoc = 0;

my @operator_lexems = qw( 
        &&  ||  ;;  <<  >>  <&  >&  <>  <<-  >|  \(  \)
        \(\(  \)\)  &>  <<<  <\(  >\(
    );

my $re_operators = "(".(join "|", map { my $a=$_; $a=~s/[\(\)\[\]\|\\\/\+\?\.\*]/\\$&/g; $a } @operator_lexems).")";

my %op_parts = ();
foreach my $op ( @operator_lexems ) {
    while ( $op ne "" ) {
        $op_parts{$op} = 1;
        $op =~ s/.\z//s;
    }
}

my $re_op_parts = "(".(join "|", map { my $a=$_; $a=~s/[\(\)\[\]\|\\\/\+\?\.\*]/\\$&/g; $a } keys %op_parts).")";


sub read_token {
    my ($self, $line, $in_quote) = @_;
    my $token = "";
    
    if ( !defined $line ) {
        $line = \$self->YYData->{LINE};
    }
    
    # The shell shall read sufficient input to determine the end of the unit
    # to be expanded (as explained in the cited sections).
    # While processing the characters, if instances of expansions or quoting are found
    # nested within the substitution, the shell shall recursively process them in the manner
    # specified for the construct that is found. The characters found from the beginning
    # of the substitution to its end, allowing for any recursion necessary to recognize
    # embedded constructs, shall be included unmodified in the result token, including
    # any embedded or enclosing substitution operators or quotes. The token shall not be
    # delimited by the end of the substitution.

    my $word = "";
    local *shift_char = sub {
        if ( $$line =~ s/^.//s ) {
            $token .= $&;
            return $&;
        }
        return '';
    };
    
    my $quotmode = ($in_quote or '');
    my @quotstack = ();
    
    my $arithm_p_count = 0;
    
    my $result = [];
    my @resultstack = ();
    
    local *set_quotmode = sub {
        my ($newquotmode) = @_;
        
        push @quotstack, $quotmode;
        $quotmode = $newquotmode;
        
        if ( $word ne "" ) {
            push @$result, $word;
            $word = "";
        }
        push @resultstack, $result;
        $result = [$newquotmode, ];
    };
    
    local *off_quotmode = sub {
        my ($close_quotmode) = @_;
        
        my $old_quotmode = $quotmode;
        $quotmode = pop @quotstack;
        if ( !defined $quotmode ) {
            print STDERR "Quotmode stack has exhausted. Token: '$token'. Line: '$$line'\n";
        }
        
        if ( $word ne "" ) {
            push @$result, $word;
            $word = "";
        }
        
        push @$result, $close_quotmode;
        
        if ( $old_quotmode eq '$' && @$result == 2 ) { # empty $ param
            $result = '$';
        } else {
            if ( $old_quotmode ne '\\' && $old_quotmode ne '"' && $old_quotmode ne "'" ) {
                $self->call_hook($self->YYData->{LINENO}, "EXPANSION", $result);
            }
        }
        
        my $prev_result = pop @resultstack;
        if ( !defined $prev_result ) {
            print STDERR "Quotresult stack has exhausted. Token: '$token'. Line: '$$line'\n";
        }
        push @$prev_result, $result;
        $result = $prev_result;
    };
    
    while ( 1 ) {
        if ( !defined $$line || $$line eq "" ) {
            if ( !$self->YYData->{NO_READLINE} ) {
                $$line = $self->read_line();
            }
            
            # If the end of input is recognized, the current token shall be delimited.
            # If there is no current token, the end-of-input indicator shall be returned
            # as the token.
            if ( !defined $$line || $$line eq "" ) {
                last; # delimit
            }
        }
        if ( !defined $quotmode ) {
            last;
        }
        
        #print "*$quotmode* $$line\n" if $line; # DBG:
        
        my $nc = "";
        if ( $$line =~ /^./s ) {
            $nc = $&;
            if ( $nc eq '\\' ) {
                $$line =~ s/^\\\n//s and redo;
            }
        }
        
        # A backslash that is not quoted shall preserve the literal value
        # of the following character.
        if ( $quotmode eq '\\' ) {
            $word .= shift_char();
            off_quotmode("");
            next;
        }
        
        if ( $quotmode eq '' || $quotmode eq '$(' ) {
            # If the previous character was used as part of an operator and the current character
            # is not quoted and can be used with the current characters to form an operator,
            # it shall be used as part of that (operator) token.
            if ( $token =~ /^$re_op_parts\z/s ) {
                if ( ($token.$nc) =~ /^$re_operators\z/s ) {
                    $word .= shift_char();
                    next;
                }
                else {
                    # If the previous character was used as part of an operator and the current
                    # character cannot be used with the current characters to form an operator,
                    # the operator containing the previous character shall be delimited.
                    last;
                }
            }
            
            # If the current character is not quoted and can be used as the first
            # character of a new operator, the current token (if any) shall be delimited.
            # The current character shall be used as the beginning of the next (operator) token.
            if ( $nc =~ /^$re_op_parts\z/s && $token ne '' ) {
                last; # delimit the token
            }
            
            # If the current character is an unquoted <newline>, the current token shall be delimited.
            if ( $nc =~ /[\n]/s ) {
                if ( $token ne '' ) {
                    last; # delimit the token
                } else {
                    $word .= shift_char();
                    last; # emit newline
                }
            }
            
            # If the current character is an unquoted <blank>, any token containing
            # the previous character is delimited and the current character shall be discarded.
            if ( $nc =~ /[ \t\r]/s ) {
                if ( $token ne '' ) {
                    last; # delimit the token
                } else {
                    $$line =~ s/^[ \t\r]+//s; # discard the current character
                    if ( $in_quote && $in_quote eq '$(' ) {
                        $token = $&;
                        last;
                    }
                    next; # continue
                }
            }
        }
        
        if ( $nc eq '\\' ) {
            if ( $quotmode eq '' || $quotmode eq '$(' || $quotmode eq '=(' || $quotmode eq '${' ) {
                shift_char();
                set_quotmode($nc);
                next;
            }
            elsif ( $quotmode eq '"' ) {
                # Enclosing characters in double-quotes ( "" ) shall preserve the literal value
                # of all characters within the double-quotes, with the exception of the characters
                # dollar sign ($), backquote (`), and backslash (\), as follows:
                # ...
                # The backslash shall retain its special meaning as an 
                # escape character (see Escape Character (Backslash)) only when followed
                # by one of the following characters when considered special:  $   `   "   \
                if ( $$line =~ /^\\[\$\`"\\]/ ) {
                    shift_char();
                    set_quotmode($nc);
                    next;
                }
            }
            elsif ( $quotmode eq '<<' ) {
                # ...the backslash in the input behaves as the backslash inside double-quotes
                # (see Double-Quotes). However, the double-quote character ( " ) shall not be
                # treated specially within a here-document.
                if ( $$line =~ /^\\[\$\`\\]/ ) {
                    shift_char();
                    set_quotmode($nc);
                    next;
                }
            }
            elsif ( $quotmode eq '`' ) {
                # Within the backquoted style of command substitution,
                # backslash shall retain its literal meaning, except when followed by:
                # '$', '`', or '\' (dollar sign, backquote, backslash).
                if ( $$line =~ /^\\[\$\`\\]/ ) {
                    shift_char();
                    set_quotmode($nc);
                    next;
                }
            }
        }
        
        if ( $quotmode eq '$' ) {
            if ( $word =~ /^\d*\z/ && $nc =~ /\d/ ) { # numeric
                $word .= shift_char();
                next;
            }
            if ( $word eq "" && $nc =~ /[@*#?\-\$!0]/ ) { # special parameter
                $word .= shift_char();
                next;
            }
            if ( $word eq "" && $nc =~ /[A-Za-z_]/ ) { # a valid first character of a variable name
                $word .= shift_char();
                next;
            }
            if ( $word =~ /^[A-Za-z_][A-Za-z_0-9]*/ && $nc =~ /[A-Za-z_0-9]/ ) { # variable name
                $word .= shift_char();
                next;
            }
            # If an unquoted '$' is followed by a character that is either not numeric,
            # the name of one of the special parameters (see Special Parameters),
            # a valid first character of a variable name, a left curly brace ( '{' ) or
            # a left parenthesis, the result is unspecified.
            if ( $word eq "" ) {
                my $prev_quotmode = '';
                if ( @quotstack ) {
                    $prev_quotmode = $quotstack[$#quotstack];
                }
                if ( $nc ne $prev_quotmode ) {
                    $self->call_hook( $self->YYData->{LINENO}, "SDOLLAR", $$line, $prev_quotmode );
                }
            }
            
            off_quotmode("");
            next;
        }
        
        #if ( $quotmode eq '$(' && $nc eq ')' ) {
            #off_quotmode($nc);
            #shift_char();
            #next;
        #}
        
        if ( $quotmode eq '$((' ) {
            if ( $nc eq '(' ) {
                $arithm_p_count++;
                $word .= shift_char();
                next;
            }
            if ( $nc eq ')' ) {
                if ( $arithm_p_count > 0 ) {
                    $arithm_p_count--;
                    $word .= shift_char();
                    next;
                }
                if ( $$line =~ s/^\)\)// ) {
                    $token .= $&;
                    off_quotmode($&);
                    next;
                }
            }
        }
        if ( $quotmode eq '${' && $nc eq '}' ) {
            off_quotmode($nc);
            shift_char();
            next;
        }
        if ( $quotmode eq '$[' && $nc eq ']' ) {
            off_quotmode($nc);
            shift_char();
            next;
        }
        if ( $quotmode eq '`' && $nc eq '`' ) {
            off_quotmode($nc);
            shift_char();
            next;
        }
        if ( $quotmode eq '=(' && $nc eq ')' ) {
            off_quotmode($nc);
            shift_char();
            next;
        }
        
        # If the current character is an unquoted '$' or '`', the shell shall identify
        # the start of any candidates for parameter expansion ( Parameter Expansion),
        # command substitution ( Command Substitution), or arithmetic expansion
        # ( Arithmetic Expansion) from their introductory unquoted character sequences:
        # '$' or '${', '$(' or '`', and '$((', respectively.
        #
        # Enclosing characters in double-quotes ( "" ) shall preserve the literal value
        # of all characters within the double-quotes, with the exception of the characters
        # dollar sign ($), backquote (`), and backslash (\).
        if ( $nc =~ /[\$\`]/ && $quotmode ne "'"  && $quotmode ne "`" ) {
            if ( $$line =~ s/^(\$\(\(|\$\(|\${|\$\[|\`|\$)// ) {
                $token .= $&;
                set_quotmode($&);
                if ( $& eq '$(' ) {
                    my $par_stack = 1;
                    while ( 1 ) {
                        # The input characters within the quoted string that are also enclosed
                        # between "$(" and the matching ')' shall not be affected by the
                        # double-quotes, but rather shall define that command whose output
                        # replaces the "$(...)" when the word is expanded. The tokenizing
                        # rules in Token Recognition , not including the alias substitutions
                        # in Alias Substitution , shall be applied recursively to find
                        # the matching ')'.
                        my ($token1) = $self->read_token($line, '$(');
                        #print "~~# $token1\n";
                        if ( $token1 eq '))' ) {
                            $token1 = ')';
                            $$line = ')'.$$line;
                        }
                        $token .= $token1;
                        if ( $token1 eq '(' || $token1 eq '<(' || $token1 eq '>(' ) {
                            $par_stack++;
                        }
                        elsif ( $token1 eq ')' ) {
                            $par_stack--;
                            if ( $par_stack == 0 ) {
                                off_quotmode($token1);
                                last;
                            }
                        }
                        elsif ( $token1 eq '' ) {
                            last;
                        }
                        $word .= $token1;
                    }
                } else {
                    $arithm_p_count = 0 if $& eq '$((';
                }
                next;
            }
        }
        
        if ( $nc =~ /['"]/ ) { # ' or  "
            if ( $quotmode eq $nc ) { # the end of quotation.
                off_quotmode($nc);
                shift_char();
                next;
            }
            if ( $quotmode eq "" || $quotmode eq '$(' || $quotmode eq '=(' || $quotmode eq '${' ) {
                # If the current character is backslash, single-quote, or double-quote
                # and it is not quoted, it shall affect quoting for subsequent characters
                # up to the end of the quoted text.
                shift_char();
                set_quotmode($nc);
                next;
            }
        }
        
        # =( Dirty hack
        if ( $nc eq '=' && ($quotmode eq '' || $quotmode eq '$(') && $$line =~ /^=\(/ ) {
            shift_char();
            shift_char();
            set_quotmode('=(');
            next;
        }
        
        if ( $quotmode eq '' || $quotmode eq '$(' ) {
            # If the previous character was part of a word, the current character
            # shall be appended to that word.
            if ( $token ne '' ) {
                $word .= shift_char();
                next;
            }
            
            # If the current character is a '#', it and all subsequent characters up to,
            # but excluding, the next <newline> shall be discarded as a comment.
            # The <newline> that ends the line is not considered part of the comment.
            if ( $nc eq '#' ) { # [The token is '' due to the previous rule.]
                $$line =~ s/^#[^\n]*//s; # discard characters up to <newline>
                my $comment = $&;
                if ( $comment =~ /\\$/ ) { # Comment ends with \<newline>
                    $self->call_hook($self->YYData->{LINENO}, "S_NEWLINE_IN_COMMENT", $comment);
                }
                next;
            }
        }
        
        # The current character is used as the start of a new word.
        $word .= shift_char();
    }
    
    while ( @quotstack ) {
        unless ( $quotmode eq '\\' || $quotmode eq '$' ) {
            $self->_Error("Unclosed quote *$quotmode*: '".limit_len($token)."'");
        }
        off_quotmode("");
    }
    
    if ( $word ne "" ) {
        push @$result, $word;
    }
    
    # The token was delimited!
    
    if ( $expect_heredoc ) { # should return a HEREDOC word
        # Quote removal shall be applied to the word to determine the delimiter
        # that is used to find the end of the here-document that begins after the next <newline>.
        my $delimiter = unquote($result);
        if ( !defined $delimiter || !$delimiter ) {
            $self->_Error("Failed to unquote HEREDOC delimiter: '".limit_len($token)."'");
        }
        my $word = "";
        while ( 1 ) {
            my $s = $self->read_line();
            if ( !defined $s ) {
                $self->_Error("EOF, but expected end of HEREDOC ($delimiter)");
                return '';
            }
            if ( $expect_heredoc == 2 ) {
                # If the redirection symbol is "<<-", all leading <tab>s shall be stripped
                # from input lines and the line containing the trailing delimiter.
                $s =~ s/^\t+//s;
            }
            $word .= $s;
            $s =~ s/[\x0d\n]$//sg;
            last if $s eq $delimiter;
        }
        $expect_heredoc = 0;
        
        # If no characters in word are quoted, all lines of the here-document shall be expanded
        # for parameter expansion, command substitution, and arithmetic expansion.
        if ( $delimiter eq $token ) {
            my $oldmode = $self->YYData->{NO_READLINE};
            $self->YYData->{NO_READLINE} = 1;
            ($token, $result) = $self->read_token(\$word, '<<'); # parse the HEREDOC text
            $self->YYData->{NO_READLINE} = $oldmode;
            return ($token, $result);
        } else {
            return $word, [$word];
        }
    }

    if ( !$in_quote ) {        
        if ( $token eq '<<' ) { # HEREDOC follows
            $expect_heredoc = 1;
        }
        elsif ( $token eq '<<-' ) {
            $expect_heredoc = 2;
        }
    }
    
    return ($token, $result);
}

sub is_name {
    my ($word) = @_;
    
    # In the shell command language, a word consisting solely of underscores, digits,
    # and alphabetics from the portable character set.
    # The first character of a name is not a digit.
    if ( $word =~ /^[A-Za-z_][A-Za-z_0-9]*\z/s ) {
        return 1;
    }
    
    return 0;
}

sub is_assignment {
    my ($word) = @_;

    if ( $word =~ /^([^=]+)=/ && is_name($1) ) {
        return 1;
    }
    
    return 0;
}

sub is_expected {
    my ($self, $token) = @_;
    
    #print_ref ($self->{GRAMMAR});
    #return 1;    
    
    my @stack = map {$_->[0]} @{$self->{STACK}};
    
    my $mode = "shift";
    my $nodefault = 1;
    my $rule = undef;
    
    #print "is_expected: TOKEN: '$token'";
    
    my $state = $stack[-1];
    
    #print "=================\n";
    
    while ( defined $state ) {
        #print "??[$mode] $state (".(defined $rule?$rule:'').")\n";
        if ( $mode eq "shift" ) {
            #print "is_expected: CHECK ('$state') $mode";
            
            if ( !exists $self->{STATES}[$state] ) {
                #print "is_expected: state ('$state') doesn't exist.\n";
                die "Should not happen";
            }
            
            if ( exists $self->{STATES}[$state]{ACTIONS} ) {
                #print( 5, "is_expected: TERMS: "
                #    .(join " ", keys %{$self->{STATES}[$state]{ACTIONS}}), "\n" );
                
                foreach my $key ( keys %{$self->{STATES}[$state]{ACTIONS}} ) {
                    if ( $token eq $key ) { return 1; }
                }
            }
            
            # default
            
            if ( !exists $self->{STATES}[$state]{DEFAULT} ) { last; }
            
            my $rule_num = -$self->{STATES}[$state]{DEFAULT};
            $rule = $self->{GRAMMAR}[$rule_num][1];
            
            #print_ref $self->{GRAMMAR}[$rule_num][2];
            my $shift_num = @{$self->{GRAMMAR}[$rule_num][2]};
            for ( my $i = 0; $i < $shift_num; $i++ ) {
                pop @stack;
            }
            
            if ( !@stack ) { die "Should not happen 3"; }
            $state = $stack[-1];
            
            #print "is_expected: reduced $shift_num";
            $mode = "reduced";
            next;
        }
        if ( $mode eq "reduced" ) {
            #print "is_expected: ('$state') REDUCED with '$rule'";
            
            if ( defined $self->{STATES}[$state]{GOTOS}
                && defined $self->{STATES}[$state]{GOTOS}{$rule} ) 
            {
                $state = $self->{STATES}[$state]{GOTOS}{$rule};
                $mode = "shift";
                push @stack, $state;
                $nodefault = 0;
                next;
            }
            
            last;
        }
    }
    #print "is_expected: stack end";
    
    return 0;
}

sub __Lexer {
    my ($self) = @_;
    
    my ($token, $struct) = $self->read_token();
    
    #print "::$token\n"; # DBG:
    #print_ref $struct; # DBG:
    
    my $tobj = [
            $token,
            $self->YYData->{LINENO},
            $struct,
        ];
    
    if ( $token eq "" ) {
        return ('', undef);
    }
    
    # 2.10.1 Shell Grammar Lexical Conventions
    
    # A <newline> shall be returned as the token identifier NEWLINE.
    if ( $token eq "\n" ) { return ('NEWLINE', $tobj); }
    
    # If the token is an operator, the token identifier for that operator shall result.
    if ( defined $operators{$token} && $self->is_expected($operators{$token}) ) {
        return ($operators{$token}, $tobj); 
    }
    
    # If the string consists solely of digits and the delimiter character is one of
    # '<' or '>', the token identifier IO_NUMBER shall be returned.
    if ( $token =~ /\A\d+\z/s && defined $self->YYData->{LINE} && $self->YYData->{LINE} =~ /^[<>]/ ) {
        if ( $self->is_expected('IO_NUMBER') ) {
            return ('IO_NUMBER', $tobj);
        }
        else {
            # Bash allows syntax like '2>&1>/dev/null'
            $self->call_hook( $self->YYData->{LINENO}, "NOT_IO_NUMBER", $token.$self->YYData->{LINE} );
        }
    }
    
    # Otherwise, the token identifier TOKEN results.
    # Further distinction on TOKEN is context-dependent.
    
    if ( defined $reserved{$token} && $self->is_expected($reserved{$token}) ) {
        return ($reserved{$token}, $tobj);
    }
    
    # Hack for discerning '))' in bash scripts and two ')' in shell scripts
    if ( $token eq "))" && ! $self->is_expected($token) ) {
        $token = $tobj->[0] = ")"; # one brace is being yelded
        $self->YYData->{LINE} = ")".$self->YYData->{LINE}; # another one is being pushed back
    }
    if ( $token eq "((" && ! $self->is_expected($token) ) {
        $token = $tobj->[0] = "("; # one brace is being yelded
        $self->YYData->{LINE} = "(".$self->YYData->{LINE}; # another one is being pushed back
    }
    
    # Syntactic tokens
    if ( $self->YYIsterm($token) && !$self->YYIssemantic($token) && $self->is_expected($token) ) {
        return ($token, $tobj);
    }
    
    # TODO:
    # Words that are the concatenation of a name and a colon ( ':' ) are reserved;
    # their use produces unspecified results.
    
    return ('WORD', $tobj);
}

# Lexer wrapper
sub _Lexer {
    my ($self) = @_;
    
    my ($type, $token) = __Lexer($self);
    
    if ( $type ne "WORD" && defined $token ) {
        delete $token->[2];
    }
    
    # DBG:
    #print "LEX#".$token->[1]."# (".$type.") '".$token->[0]."'\n";
    #my @expected = $self->YYExpect();
    #print "EXP## @expected\n";
    
    return ($type, $token);
}

sub _Error {
    my ($self, $msg) = @_;
    
    if ( !defined $msg ) { # Parser's error
        my $token = $self->YYCurval;
        
        my $linenum = $token ? $token->[1] : 0;

        $self->call_hook($linenum, "PARSERERR");
        
        my @expected = $self->YYExpect();
        print "EXPECTED# @expected\n";
        
        #print "Parse error: near '".($token ? $token->[0] : "")."'";
    } else {
        $self->call_hook($self->YYData->{LINENO}, "MISCERR", $msg);
        
        #print "Error at line ".$self->YYData->{LINENO}.": ".$msg;
    }

    #die "DBG: parser failed"; # DBG:
}

sub Run {
    my ($self, $filename, $text_ref) = @_;
    
    # Set the input
    $self->YYData->{FILENAME} = $filename;
    $self->YYData->{INPUT} = $$text_ref;

    $self->YYParse( yylex => \&_Lexer, yyerror => \&_Error );
}

#-----------------------------------------------------------------------

#line 7436 ShParser.pm

1;
